#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "ndl.h"

inline int isMaskedPattern(const char *pattern)
{
    if(strchr(pattern,'*'))return 1;
    if(strchr(pattern,'?'))return 1;
    if(strchr(pattern,'#'))return 1;
    return 0;
}

inline int compNull( short pattern, short entity )
{
    if( pattern >= 0 )return pattern == entity;
    else return 1;
}

inline cmpAddressNoPattern(const tAddress& pattern, const tAddress& cur)
{
    return  compNull( pattern.Zone, cur.Zone ) &&
            compNull( pattern.Net , cur.Net  ) &&
            compNull( pattern.Node, cur.Node ) ;
}


char __inline_makeCharAddress_tmpextern[28];

inline char* makeCharAddress(const tAddress& add)
{
    sprintf(&__inline_makeCharAddress_tmpextern[0],"%d:%d/%d.%d",add.Zone,add.Net,add.Node,add.Point);
    return &__inline_makeCharAddress_tmpextern[0];
}

inline int cmpAddressPattern(const char *pattern, const char* tmp)
{
    int i;

    for(i=0;*pattern && tmp[i];i++,pattern++){
        if(*pattern=='*')return 1;
        if(*pattern=='?')continue;
        if(*pattern=='#'){
            while(tmp[i] && isdigit(tmp[i]))i++;
            i--;
            continue;
        }
        if(*pattern!=tmp[i])return 0;
    }
A1: if((!tmp[i]) && (!*pattern))return 1;
    if(*pattern=='*')return 1;
    if(*pattern=='#'){
        while(tmp[i] && isdigit(tmp[i]))i++;
        pattern++;
        goto A1;
    }
    return 0;
}

inline int cmpAddressPattern(const char *pattern, const tAddress& add)
{
    const char *tmp;

    tmp=makeCharAddress(add);
    return cmpAddressPattern(pattern,tmp);
}

void main(int ac, char *av[])
{
    tAddress add;
    int ret;

    printf("address compare utility for sf-nc nodelist compiler v1.6\n");
    printf("copyright (c) Stanislav V. Mekhanoshin (2:5030/143.23)\n");
    if(ac != 3){
        printf("usage: compaddr <pattern> <full-4D-address>");
        return;
    }
    sscanf(av[2],"%d:%d/%d.%d",&add.Zone,&add.Net,&add.Node,&add.Point);
    if(isMaskedPattern(av[1])){
        printf("using string pattern\n");
        printf("comparing pattern \"%s\" with %s\n",av[1],makeCharAddress(add));
        ret = cmpAddressPattern(av[1],add);
    }else{
        tAddress ptrn;
        printf("using binary pattern\n");
        setAddress(ptrn);
        sscanf(av[1],"%d:%d/%d.%d",&ptrn.Zone,&ptrn.Net,&ptrn.Node,&ptrn.Point);
        printf("comparing pattern %s with ",makeCharAddress(ptrn));
        printf("%s\n",makeCharAddress(add));
        ret = cmpAddressNoPattern(ptrn,add);
    }
    printf("returns: %s", ret?"true":"false");
}
