#ifndef __CALLBACK_H__
#define __CALLBACK_H__

#ifdef __cplusplus
extern "C" {
#endif

#if defined(__OS2__)
#include <os2def.h>
#define _CALLBACK APIRET APIENTRY
#define _CALLBACKRET APIRET
#elif defined(__NT__)
#include <windows.h>
#define _CALLBACK int __syscall
#define _CALLBACKRET int
#else
#define _CALLBACK int
#define _CALLBACKRET int
#endif

#include "sfncstat.h"

#if !defined(__OS2__) && !defined(__NT__)
extern _CALLBACK  _cfLogLine(char *str,long);
extern _CALLBACK  _cfError(int level, char *str, int line, long);
extern _CALLBACK  _cfGauge(int perc,long);
extern _CALLBACK  _cfDrawTotal(SfNcStat *pStat,long);
extern _CALLBACK  _cfDrawLogo(char *__PID__, char *__CID__, char *__VID__,long);
extern _CALLBACK  _cfDrawScreen(long);
extern _CALLBACK  _cfDrawFinal(float etime,float stime,long aspeed,long sspeed,SfNcStat *pStat,long UDP);
#endif
extern _CALLBACK  _ccLogLine(char *str,long);
extern _CALLBACK  _ccError(int level, char *str,int line,long);
extern _CALLBACK  _ccDrawLogo(char *__PID__, char *__CID__, char *__VID__,long);
extern _CALLBACK  _ccDrawFinal(float etime,float stime,long aspeed,long sspeed,SfNcStat *pStat,long UDP);

extern _CALLBACK (*_cLogLine)(char *str,long);
extern _CALLBACK (*_cError)(int level,char *str,int line,long);
extern _CALLBACK (*_cGauge)(int perc,long);
extern _CALLBACK (*_cDrawTotal)(SfNcStat *pStat,long);
extern _CALLBACK (*_cDrawLogo)(char *__PID__, char *__CID__, char *__VID__,long);
extern _CALLBACK (*_cDrawScreen)(long);
extern _CALLBACK (*_cDrawFinal)(float etime,float stime,long aspeed,long sspeed,SfNcStat *pStat,long UDP);
extern long _UDP;

#ifdef __cplusplus
}
#endif

#endif
