#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <io.h>
#include <ctype.h>
#include <malloc.h>
#include <limits.h>
#include "sf-nc.h"
#include "ndl.h"
#include "hptr.h"

#if defined(__386__)
    #define __Inline inline
#else
    #define __Inline
#endif

tNodeIdxRec *index=NULL;
extern "C"{
SfNcStat Stat={0L,0L,0L,0L,0L,0L};
}

// #pragma intrinsic(strncmp,strchr);

static int fill = HEAP_GRANULARITY;
static tNodeIdxRec cur;
static char __inline_makeCharAddress_tmpextern[28];

static long step;
static long curstep;

#if !defined(__386__)
    #define realloc huge_realloc
#endif

__Inline static int compNull( short pattern, short entity )
{
    if( pattern >= 0 )return pattern == entity;
    return 1;
}

__Inline cmpAddressNoPattern(const tAddress& pattern, const tAddress& cur)
{
    return  compNull( pattern.Zone, cur.Zone ) &&
            compNull( pattern.Net , cur.Net  ) &&
            compNull( pattern.Node, cur.Node ) ;
}

__Inline char* makeCharAddress(const tAddress& add)
{
    sprintf(&__inline_makeCharAddress_tmpextern[0],"%d:%d/%d.%d",add.Zone,add.Net,add.Node,add.Point);
    return &__inline_makeCharAddress_tmpextern[0];
}

__Inline int cmpAddressPattern(const char *pattern, const char* tmp)
{
    int i;

    for(i=0;*pattern && tmp[i];i++,pattern++){
        if(*pattern=='*')return 1;
        if(*pattern=='?')continue;
        if(*pattern=='#'){
            while(tmp[i] && isdigit(tmp[i]))i++;
            i--;
            continue;
        }
        if(*pattern!=tmp[i])return 0;
    }
A1: if((!tmp[i]) && (!*pattern))return 1;
    if(*pattern=='*')return 1;
    if(*pattern=='#'){
        while(tmp[i] && isdigit(tmp[i]))i++;
        pattern++;
        goto A1;
    }
    return 0;
}

__Inline int cmpAddressPattern(const char *pattern, const tAddress& add)
{
    const char *tmp;

    tmp=makeCharAddress(add);
    return cmpAddressPattern(pattern,tmp);
}

static int save( int NdlNo )
{
    int i;

    if( NdlInfo[ NdlNo ].Masked )makeCharAddress(cur.Address);
    if( NdlInfo[ NdlNo ].IncludeCnt ){
        for( i=0; i<NdlInfo[ NdlNo ].IncludeCnt; i++ ){
            if(NdlInfo[ NdlNo ].IncludeList[i].Masked){
                if( cmpAddressPattern( NdlInfo[ NdlNo ].IncludeList[i].Mask.Pattern, __inline_makeCharAddress_tmpextern ) )goto Excl;
            }else
                if( cmpAddressNoPattern( NdlInfo[ NdlNo ].IncludeList[i].Mask.Bin, cur.Address ) )goto Excl;
        }
        return 0;
    }
Excl:
    for( i=0; i<NdlInfo[ NdlNo ].ExcludeCnt; i++ ){
        if(NdlInfo[ NdlNo ].ExcludeList[i].Masked){
            if( cmpAddressPattern( NdlInfo[ NdlNo ].ExcludeList[i].Mask.Pattern, __inline_makeCharAddress_tmpextern ) )return 0;
        }else
            if( cmpAddressNoPattern( NdlInfo[ NdlNo ].ExcludeList[i].Mask.Bin, cur.Address ) )return 0;
    }
    return 1;
}

__Inline unsigned short crc16(unsigned char inpbyte, unsigned short oldCRC)
{
    register unsigned short temp = oldCRC;
    register int tel;

    temp ^= (unsigned short)(((unsigned short)inpbyte)<<8);
    temp &= 0xFF00;
    for( tel=0; tel<8; tel++ ){
      if( temp & 0x8000u){
        temp <<= 1;
        temp ^= 0x1021u;
      }else
        temp <<= 1;
    }      
    return temp ^= (unsigned short)(oldCRC<<8);
}

void collectRec( unsigned char NdlNo )
{
    char in[256];
    long flen;
    int gstep=0;
    short lastRegion=NdlInfo[ NdlNo ].DefRegion, lastHub=0;
    unsigned short crc=0;
    unsigned short crcexp;
    int firstline = 1;

    if( NdlInfo[ NdlNo ].DefZone == -1 )NdlInfo[ NdlNo ].DefZone = 0;
    if( NdlInfo[ NdlNo ].DefNet == -1 )NdlInfo[ NdlNo ].DefNet = 0;
    setAddress( cur.Address, NdlInfo[ NdlNo ].DefZone, NdlInfo[ NdlNo ].DefNet, 0, 0 );
    cur.NdlOfs = ftell( handleNdl );
    cur.RouteNode = 0;
    cur.Address.Point = 0;
    cur.NdlNo = (unsigned char)(NdlNo+1);
    in[0]=0;
    flen = filelength( fileno(handleNdl) );
    gaugePos(0);
    step=flen/GAUGE_LEN;
    curstep=0l;
    while( fgets( in, 256, handleNdl ) ){
        if( NdlInfo[ NdlNo ].Crc ){
            int i;
            if(firstline){
                firstline = 0;
                if( in[0] != ';' || in[1] != 'A' )error(5, "nodelist crc absent");
                for( i = strlen(in)-1; i > 0; i-- )if(!isspace(in[i]))break;
                i-=4;
                crcexp = (unsigned short)atoi(&in[i]);
            }else{
                for( i=0; in[i] && in[i]!=0x1A; i++ )crc=crc16((unsigned char)in[i],crc);
            }
        }
        if( in[0] < 0x20 )goto Next;
        if( in[0] == ';' )goto Next;
        if( NdlInfo[ NdlNo ].Type == LT_NODELIST ){
            cur.Address.Point = 0;
            if( !strncmp( in, "Zone,", 5 ) ){
                cur.Address.Zone = (short)atoi( in+5 );
                cur.Address.Net = cur.Address.Zone;
                lastHub = cur.RouteNode = cur.Address.Node = lastRegion = 0;
                if(save(NdlNo)){
                    Stat.ZoneCnt++;
                    cur.NdlOfs |= M_ZONE;
                    goto Save;
                }else goto Next;
            }
            if( !strncmp( in, "Region,", 7 ) ){
                lastRegion = cur.Address.Net = cur.RouteNode = (short)atoi( in+7 );
                lastHub = cur.Address.Node = 0;
                if(save(NdlNo)){
                    Stat.RegionCnt++;
                    cur.NdlOfs |= M_REGION;
                    goto Save;
                }else goto Next;
            }
            if( !strncmp( in, "Host,", 5 ) ){
                cur.Address.Net = (short)atoi( in+5 );
                cur.RouteNode = lastRegion;
                lastHub = cur.Address.Node = 0;
                if(save(NdlNo)){
                    Stat.HostCnt++;
                    cur.NdlOfs |= M_HOST;
                    goto Save;
                }else goto Next;
            }
            if( !strncmp( in, "Hub,", 4 ) ){
                lastHub = cur.RouteNode = cur.Address.Node = (short)atoi( in+4 );
                if(save(NdlNo)){
                    Stat.HubCnt++;
                    cur.NdlOfs |= M_HUB;
                    goto Save;
                }else goto Next;
            }
            if( !strncmp( in, "Point,", 6 ) ){  // 4D-Point support
                cur.RouteNode = cur.Address.Node;
            	cur.Address.Point = (short)atoi( in+6 );
                if(save(NdlNo))goto Save;
                else goto Next;
            }
            cur.RouteNode = lastHub;
            cur.Address.Node = (short)atoi( strchr( in, ',' )+1 );
        }else{
            if( !strncmp( in, "Boss,", 5 ) ){
                sscanf( in+5, "%d:%d/%d", &cur.Address.Zone, &cur.Address.Net, &cur.Address.Node );
                goto Next;
            }
            cur.Address.Point = (short)atoi( strchr(in,',')+1 );
            cur.RouteNode = cur.Address.Node;
            if(save(NdlNo))goto Save;
            else goto Next;
        }
        if( !save(NdlNo) )goto Next;
Save:
//        if( !(indexlen%50) )drawTotal();
        if( fill == HEAP_GRANULARITY ){
            unsigned long newsize = (Stat.indexlen+HEAP_GRANULARITY)*sizeof(tNodeIdxRec);
//            if(newsize > UINT_MAX)goto ENOMEM;
            index = (tNodeIdxRec*)realloc( index, newsize );
            if( !index ){
                error( 4, "cannot allocate enough memory" );
            }
            fill = 0;
        }

        memcpy(
#if defined(__386__)
            &index[ Stat.indexlen ]
#else
            hptr_add( index, Stat.indexlen )
#endif
            , &cur, sizeof( tNodeIdxRec ) );
        Stat.indexlen++;
        fill++;
Next:

        in[0] = 0;
        cur.NdlOfs = ftell( handleNdl );
        while(cur.NdlOfs >= curstep){
            gaugePos(++gstep);
            curstep+=step;
            drawTotal();
        }
    }
    if( NdlInfo[ NdlNo ].Crc ){
        if( crc != crcexp )error( 5, "crc mismatch: expected %u, calculated %u", crcexp, crc );
        plog( "nodelist crc: %u", crc );
    }
    drawTotal();
    gaugePos(0);
}
