#include <malloc.h>
#include <dos.h>
#include <stdlib.h>
#include "hptr.h"

#define CHECKMEM_METHOD_MCBWALK
// #define CHECKMEM_METHOD_GETMEM
// #define SHRINK_HEAP

void far* huge_malloc(unsigned long size)
{
    unsigned short newseg;

#ifdef SHRINK_HEAP
    _nheapshrink();
    _fheapshrink();
#endif
    if(_dos_allocmem((size + 15) >> 4,&newseg))newseg=0;
    return MK_FP(newseg,0);
//    return (void far*)halloc(size,1);
}

void far* farptr_norm(void far* p)
{
    unsigned short off=FP_OFF(p);
    if(off&0xF0)p=MK_FP(FP_SEG(p)+(off>>4),off&0x0F);
    return p;
}

void far* farptr_fromlong(long a)
{
    return MK_FP((a&~0x0FL)>>4,a&0x0F);
}

long farptr_tolong(void far* a)
{
    return (((long)FP_SEG(a))<<4)+FP_OFF(a);
}

void far* hugeptr_add(void far* p, long inc)
{
    return farptr_fromlong(farptr_tolong(p)+inc);
}

long hugeptr_diff(void far* p1, void far *p2)
{
    return farptr_tolong(p1)-farptr_tolong(p2);
}

struct MCB far* Dos_Get1stMCB(void)
{
    union  REGS  regs;
    struct SREGS sregs;

    regs.h.ah = 0x52;
    int86x( 0x21, &regs, &regs, &sregs );
    return MK_FP(*(unsigned short*)hugeptr_add(MK_FP(sregs.es,regs.x.bx),-2),0);
}

unsigned long huge_contigmemavail(void)
{
#if defined(CHECKMEM_METHOD_GETMEM)
    union  REGS  regs;
    struct SREGS sregs;
    unsigned long retval;

#ifdef SHRINK_HEAP
    _nheapshrink();
    _fheapshrink();
#endif
    regs.h.ah = 0x48;
    regs.x.bx = 0xFFFF;
    int86( 0x21, &regs, &regs );
    if(!regs.x.cflag){
        retval=0xFFFF;
        sregs.es = regs.x.ax;
        regs.h.ah = 0x49;
        int86x( 0x21, &regs, &regs, &sregs );  //free
    }else retval = regs.x.bx;
    return retval<<4;
#elif defined(CHECKMEM_METHOD_MCBWALK)
    struct MCB far *p;
    unsigned long max=0;

#ifdef SHRINK_HEAP
    _nheapshrink();
    _fheapshrink();
#endif
    for( p=Dos_Get1stMCB(); ; p=hugeptr_add(p,sizeof(struct MCB)+(((long)(p->ParaSize))<<4)) ){
        if(!p->OwnerPSP)if(max<p->ParaSize)max=p->ParaSize;
        if (p->Type == MCB_LAST) break;
    }
    return max<<4;
#else
#error !No method
#endif
}

void far * huge_realloc(void far *oldptr,unsigned long newsize)
{   unsigned short oldseg,newseg,newpar,oldpar;
    int errsave;
    unsigned long i;
    register unsigned short j;
    unsigned char far *src, far *dst;

    if (FP_OFF(oldptr))goto ret0;           /* oldptr is a bad pointer  */
    oldseg = FP_SEG(oldptr);
    if (newsize == 0){
        if( oldseg )_dos_freemem(oldseg);
ret0:   return 0;
    }
#ifdef SHRINK_HEAP
    _nheapshrink();
    _fheapshrink();
#endif
    if (oldseg == 0)                        /* if oldptr is NULL        */
    return huge_malloc(newsize);
#if defined(__OS2__) || defined(DOS16RM)
    if (newsize >= 0x1000000)
#else
    if (newsize >= 0x100000)
#endif
    goto ret0;                              /* can't allocate that much */
                                            /* Attempt to just resize the block */
    newpar = (newsize + 15) >> 4;           /* # of paragraphs      */
    errsave = errno;
    errno = 0;
    _dos_setblock(newpar,oldseg,(unsigned*)&newseg);
    if (errno == 0){                        /* if successful        */
        errno = errsave;
        return oldptr;                      /* we resized in place      */
    }
    errno = errsave;
                                            /* Allocate new block and copy */
    oldpar = *(unsigned far *)MK_FP(oldseg - 1,3);
    if(_dos_allocmem(newpar,&newseg))
        goto ret0;                          /* failed to allocate a new one */

    for( i=0; i< (newpar < oldpar ? newpar : oldpar); i+=16 ){
        src = hugeptr_add((char*)MK_FP(oldseg,0),i);
        dst = hugeptr_add((char*)MK_FP(newseg,0),i);
        for(j=0;j<16;j++){
            dst[j] = src[j];
        }
    }

    _dos_freemem(oldseg);
    return MK_FP(newseg,0);
}

int huge_makepool(size_t size)
{
    void *p;

    _heapenable(1);
    if(size){
        _heapgrow();
        p=malloc(size);
        _heapshrink();
        if(p)free(p);
    }else p=&p;
    _heapenable(0);
    return p?1:0;
}

