#ifndef __HUGEPTR_H
#define __HUGEPTR_H

#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif

#if defined(__386__)

#define hptr_diff(h1,h2) ((h1) - (h2))
#define hptr_add(h1,offset) ((h1) + (offset))

#else

#pragma pack(push,1);

#define MCB_LAST    0x5A
#define MCB_NORMAL  0x4D

struct MCB{
    unsigned char       Type;
    unsigned short      OwnerPSP;
    unsigned short      ParaSize;
    unsigned char       Unused[3];
    unsigned char       Name[8];
};


void far* huge_malloc(unsigned long size);
void far* farptr_norm(void far* p);
void far* farptr_fromlong(long a);
long farptr_tolong(void far* a);
void far* hugeptr_add(void far* p, long inc);
long hugeptr_diff(void far* p1, void far *p2);
struct MCB far* Dos_Get1stMCB(void);
unsigned long huge_contigmemavail(void);
void far* huge_realloc(void far *oldptr,unsigned long newsize);
int huge_makepool(size_t size);

void huge_qsort( char far* base, unsigned long nel, int width, int (* comp_fp)(const void far*, const void far*));

#define hptr_diff(h1,h2) (hugeptr_diff((h1),(h2)) / sizeof(*h1))
#define hptr_add(h,offset) (hugeptr_add(h,((long)(offset)) * sizeof(*(h))))
#define qsort huge_qsort

#pragma pack(pop);

// #pragma alloc_text( __farptr_text, farptr_norm,farptr_fromlong,farptr_tolong,hugeptr_add,hugeptr_diff,Dos_Get1stMCB,huge_contigmemavail,huge_realloc,huge_makepool,huge_malloc);
// #pragma alloc_text( __huge_qsort_text, huge_qsort );

#endif

#ifdef __cplusplus
}
#endif

#endif /* __HUGEPTR_H */
