#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>
#include <time.h>
#include <setjmp.h>
#include "callback.h"

extern int line;
extern FILE *handleLog;
extern jmp_buf unwind_buf;

extern "C"{
short GAUGE_LEN;
}

void gaugePos(int perc)
{
    if(_cGauge)_cGauge(perc,_UDP);
}

void plog( char *format, ... )
{
    va_list argptr;
    char str[300];

    va_start( argptr, format );
    vsprintf( str, format, argptr );
    va_end( argptr );

    if(str[0]!='\b'){
        if(_cLogLine)_cLogLine(str,_UDP);
    }
    if(handleLog){
        struct tm *tp;
        time_t now;
        time(&now);
        char buf[24];
        tp=localtime(&now);
        strftime(buf,sizeof(buf),"%d-%b-%Y %H:%M:%S ",tp);
        if(str[0]!='\b')fputs(buf,handleLog);
        fputs(str[0]=='\b'?&str[1]:str,handleLog);
        fputc('\n',handleLog);
    }
}

void error( int level, char *format, ... )
{
    va_list argptr;
    char str[300];

    va_start( argptr, format );
    vsprintf( str, format, argptr );
    va_end( argptr );

    if(_cError)_cError(level,str,line,_UDP);
    if(handleLog){
        if(level)fprintf(handleLog,"execution failed at line %d of configuration file:\n",line);
        fputs(str,handleLog);
        fputc('\n',handleLog);
    }
    longjmp( unwind_buf, level?level:-1 );
}

void drawTotal(void)
{
    if(_cDrawTotal)_cDrawTotal(&Stat,_UDP);
}

void drawLogo(char *__PID__, char *__CID__, char *__VID__)
{
    if(_cDrawLogo)_cDrawLogo(__PID__,__CID__,__VID__,_UDP);
}

void drawScreen(void)
{
    if(_cDrawScreen)_cDrawScreen(_UDP);
}

void drawFinal(float etime,float stime,long aspeed,long sspeed)
{
    if(_cDrawFinal)_cDrawFinal(etime,stime,aspeed,sspeed,&Stat,_UDP);
}
