#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <malloc.h>
#include <ctype.h>
#include <fcntl.h>
#include <share.h>

#if defined(__OS2__)
#include <os2def.h>
APIRET APIENTRY CompileNodelist();
#include "prodinfo.h"
#elif defined(__NT__)
#include <windows.h>
int __syscall CompileNodelist();
#include "prodinfo.h"
#else
extern int CompileNodelist();
extern char* __PID__;
extern char* __CID__;
extern char* __VID__;
#endif

#include "callback.h"
#include "hptr.h"

#define GAUGE_LEN 52

#if defined(__386__) && !defined(__OS2__)

#include <vidmgr.h>

static short disp_numrows;
static short disp_numcols;
static short logrow=10;

static char C_NORMAL         =  vm_mkcolor(LIGHTGRAY,BLACK);
static char C_LOG            =  vm_mkcolor(CYAN,BLACK);
static char C_TOTALLABEL     =  vm_mkcolor(YELLOW,BLUE);
static char C_TOTALINFO      =  vm_mkcolor(LIGHTCYAN,BLUE);
static char C_GAUGE          =  vm_mkcolor(LIGHTCYAN,BLUE);
static char C_ID             =  vm_mkcolor(BLACK,CYAN);


static void vmadd_scrollbox(char x1, char y1, char x2, char y2)
{                              
#if defined(__OS2__)
    char *buff;

    buff=(char*)alloca((x2-x1)<<1);
    for( ; y1<y2; y1++ ){
        vm_gettext(x1, y1+1, x2, y1+1, buff );
        vm_puttext(x1, y1, x2, y1, buff );
    }
#else
    char i;

    for( ; y1<y2; y1++)
        for( i=x1; i<=x2; i++ )
            vm_putch( i, y1, vm_getchxy( i, y1+1 ));
#endif
    vm_clearbox( x1, y2, x2, y2 );
}

#pragma off (unreferenced)
_CALLBACK _cfLogLine(char *str,long UDP)
{                              
    char term;

Start:
    term = NULL;
    if( logrow == (disp_numrows-1) )
        vmadd_scrollbox( 2, 11, disp_numcols-1, disp_numrows-1 );
    else logrow++;
    if( strlen(str) > (disp_numcols-2) ){
        term = str[disp_numcols-2];
        str[disp_numcols-2] = NULL;
    }
    vm_puts( 2, logrow, str);
    if(term){
        str[disp_numcols-2] = term;
        str += disp_numcols-2;
        goto Start;
    }                           
    return (_CALLBACKRET)0;
}

_CALLBACK _cfError(int level,char *str,int line,long UDP)
{
    vm_paintclearbox( 1, 4, disp_numcols, disp_numrows, C_NORMAL );
    vm_gotoxy( 1, 5 );
#if !defined(__NT__)
    vm_done();
#endif
    _ccError(level,str,line,UDP);
#if defined(__NT__)
    vm_done();
#endif
    return (_CALLBACKRET)0;
}

static short gauge;

_CALLBACK _cfGauge(int perc,long UDP)
{                            
    if(!perc){
        vm_fillbox( 23, 8, (char)(22+GAUGE_LEN), 8, '' );
        gauge = 0;
    }else{
        if( gauge < GAUGE_LEN && perc >= gauge ){
            for( perc-=gauge; perc && gauge <= GAUGE_LEN; perc-- ){
                vm_putch( (char)(23+gauge++), 8, '' );
            }
        }
    }                      
    return (_CALLBACKRET)0;
}

_CALLBACK _cfDrawTotal(SfNcStat *pStat,long UDP)
{

    vm_printf( 23, 5, "%-8ld", pStat?pStat->indexlen-pStat->DupeCnt:0L );
    vm_printf( 43, 5, "%-8ld", pStat?pStat->ZoneCnt:0L );
    vm_printf( 65, 5, "%-8ld", pStat?pStat->RegionCnt:0L );
    vm_printf( 23, 6, "%-8ld", pStat?pStat->HostCnt:0L );
    vm_printf( 43, 6, "%-8ld", pStat?pStat->HubCnt:0L );
    vm_printf( 65, 6, "%-8ld", pStat?pStat->DupeCnt:0L );
    return (_CALLBACKRET)0;
}

_CALLBACK _cfDrawLogo(char *__PID__, char *__CID__, char *__VID__,long UDP)
{
    vm_init();
    vm_clearscreen();
    vm_setcursorstyle(CURSORHIDE);
    disp_numrows = vm_getscreenheight();
    disp_numcols = vm_getscreenwidth();
    vm_paintclearbox( 1, 1, disp_numcols, 3, C_ID );
    vm_printfcenter(1,__PID__);
    vm_printfcenter(2,__CID__);
    vm_printfcenter(3,__VID__);
    return (_CALLBACKRET)0;
}

_CALLBACK _cfDrawScreen(long UDP)
{
    vm_paintclearbox( 1, 4, disp_numcols, 9, C_TOTALLABEL );
    vm_frame( 1, 4, disp_numcols, 7, C_TOTALLABEL, vm_frame_single );
    vm_frame( 1, 7, disp_numcols, 9, C_TOTALLABEL, vm_frame_single );
    vm_putch( 1, 7, '' );
    vm_putch( disp_numcols, 7, '' );
    vm_puts( 8, 5, "total systems:              zones:              regions:" );
    vm_puts( 16, 6, "hosts:               hubs:                dupes:" );
    vm_paintclearbox( 23, 5, 31, 6, C_TOTALINFO);
    vm_paintclearbox( 43, 5, 51, 6, C_TOTALINFO);
    vm_paintclearbox( 65, 5, 73, 6, C_TOTALINFO);
    _cfDrawTotal(NULL,UDP);

    vm_puts( 4, 8, "current operation:" );
    vm_paintclearbox( 23, 8, (char)(22+GAUGE_LEN), 8, C_GAUGE );

    vm_paintclearbox( 1, 10, disp_numcols, disp_numrows, C_LOG );
    vm_frame( 1, 10, disp_numcols, disp_numrows, C_LOG, vm_frame_single );
    return (_CALLBACKRET)0;
}

_CALLBACK _cfDrawFinal(float etime,float stime,long aspeed,long sspeed,SfNcStat *pStat,long UDP)
{
    vm_paintclearbox( 1, 7, disp_numcols, 10, C_TOTALLABEL );
    vm_frame( 1, 7, disp_numcols, 10, C_TOTALLABEL, vm_frame_single );
    vm_putch( 1, 7, '' );
    vm_putch( disp_numcols, 7, '' );
    vm_printf( 4, 8, "elapsed time:%13ssec", "" );
    vm_printf( 45, 8, "sort time:%13ssec", "" );
    vm_printf( 4, 9, "average speed:%12snode/sec", "" );
    vm_printf( 45, 9, "sort speed:%12snode/sec", "" );
    vm_xprintf( 19, 8, C_TOTALINFO, "%10.2f",etime);
    vm_xprintf( 57, 8, C_TOTALINFO, "%10.2f",stime);
    vm_xprintf( 19, 9, C_TOTALINFO, "%10ld", aspeed );
    vm_xprintf( 57, 9, C_TOTALINFO, "%10ld", sspeed );
    vm_paintclearbox( 1, 11, disp_numcols, disp_numrows, C_NORMAL );
    vm_gotoxy( 1, 12 );
    vm_done();
    return (_CALLBACKRET)0;
}

#endif // __386__ && !__OS2__

_CALLBACK _ccLogLine(char *str,long UDP)
{
    puts(str);
    return (_CALLBACKRET)0;
}

_CALLBACK _ccError(int level,char *str,int line,long UDP)
{
    if(level)printf( "execution failed at line %d of configuration file:\n", line );
    puts( str );
    return (_CALLBACKRET)0;
}

_CALLBACK _ccDrawLogo(char *__PID__, char *__CID__, char *__VID__,long UDP)
{
        puts(__PID__);
        puts(__CID__);
        puts(__VID__);
        puts("");
        return (_CALLBACKRET)0;
}

_CALLBACK _ccDrawFinal(float etime,float stime,long aspeed,long sspeed,SfNcStat *pStat,long UDP)
{
    printf( "\ntotal systems: %-8ld      zones: %-8ld     regions: %-8ld\n", pStat->indexlen-pStat->DupeCnt,pStat->ZoneCnt,pStat->RegionCnt );
    printf( "hosts:         %-8ld      hubs:  %-8ld     dupes:   %-8ld\n\n", pStat->HostCnt,pStat->HubCnt,pStat->DupeCnt );

    printf( "elapsed time:  %10.2f sec       ", etime );
    printf( "sort time:  %10.2f sec\n", stime );
    printf( "average speed: %10ld node/sec  ", aspeed );
    printf( "sort speed: %10ld node/sec\n", sspeed );
    return (_CALLBACKRET)0;
}
#pragma on (unreferenced)

#if defined(__386__) && !defined(__OS2__)
    _CALLBACK (*_cLogLine)(char *str,long)=_cfLogLine;
    _CALLBACK (*_cError)(int level,char *str,int line,long)=_cfError;
    _CALLBACK (*_cGauge)(int perc,long)=_cfGauge;
    _CALLBACK (*_cDrawTotal)(SfNcStat *pStat,long)=_cfDrawTotal;
    _CALLBACK (*_cDrawLogo)(char *__PID__, char *__CID__, char *__VID__,long)=_cfDrawLogo;
    _CALLBACK (*_cDrawScreen)(long)=_cfDrawScreen;
    _CALLBACK (*_cDrawFinal)(float etime,float stime,long aspeed,long sspeed,SfNcStat *pStat,long UDP)=_cfDrawFinal;
#else
    _CALLBACK (*_cLogLine)(char *str,long)=_ccLogLine;
    _CALLBACK (*_cError)(int level,char *str,int line,long)=_ccError;
    _CALLBACK (*_cGauge)(int perc,long)=NULL;
    _CALLBACK (*_cDrawTotal)(SfNcStat *pStat,long)=NULL;
    _CALLBACK (*_cDrawLogo)(char *__PID__, char *__CID__, char *__VID__,long)=_ccDrawLogo;
    _CALLBACK (*_cDrawScreen)(long)=NULL;
    _CALLBACK (*_cDrawFinal)(float etime,float stime,long aspeed,long sspeed,SfNcStat *pStat,long UDP)=_ccDrawFinal;
#endif

int main( int ac, char *av[] )
{
    int i;
    char config[128];
    char force=0;
    static char configname[] = "sf-nc.cfg";
    FILE *tmpHandle;

#if !defined(__386__)
    huge_makepool(0x4000);
#endif

    config[0] = NULL;
    for( i=1; i<ac; i++ )
        if( (av[i][0] == '-') || (av[i][0] == '/') )switch(tolower(av[i][1])){
            case 'c': strcpy( config, &av[i][2] );
                      break;
            case 'n':
#if defined(__386__) && !defined(__OS2__)
                      _cLogLine   = _ccLogLine;
                      _cError     = _ccError;
                      _cGauge     = NULL;
                      _cDrawTotal = NULL;
                      _cDrawLogo  = _ccDrawLogo;
                      _cDrawScreen= NULL;
                      _cDrawFinal = _ccDrawFinal;
#endif
                      break;
            case 'f': force = 1;
                      break;
            default:
                      goto USAGE;
        }else{
USAGE:                puts(__PID__);
                      puts(__CID__);
                      puts(__VID__);
                      printf( "\nusage: sf-nc [{-|/}<option>]\n\n\
  <option> ::== { c<File-Spec>] /* configuration file */ |\n\
                  n             /* console interface  */ |\n\
                  f             /* force compilation  */   }\n" );
                      return 1;
        }
    if(!config[0]){
        strcpy( config, configname );
        tmpHandle = _fsopen( config, "r", SH_DENYNO );
        if( tmpHandle )fclose(tmpHandle);
        else{
            for( i=strlen(av[0]); i>=0 && av[0][i]!='\\'; i-- )continue;
            if( i > 0 )strncpy( config, av[0], i+1 );
            strcpy( &config[i+1], configname );
        }
    }
    return CompileNodelist( config, force, (short)GAUGE_LEN,
                            _cLogLine, _cError, _cGauge,
                            _cDrawTotal, _cDrawLogo, _cDrawScreen,
                            _cDrawFinal, 0L );
}
