Unit MainForm;

Interface

Uses
  Classes, Forms, StdCtrls, Buttons, SysUtils, StdDlgs;

function CompileNodelist(config:PChar;force:byte;gaugeLen:word;LogLine,Error,Gauge,DrawTotal,DrawLogo,DrawScreen,DrawFinal:Pointer;UDP:LongInt):LongInt;
        cdecl;external 'sf-ncp' name 'COMPILENODELIST';

Type
  TPanel1 = Class (TPanel)
    SystemCntL: TLabel;
    HostCntL: TLabel;
    ZoneCntL: TLabel;
    HubCntL: TLabel;
    RegionCntL: TLabel;
    DupeCntL: TLabel;
    SystemCnt: TLabel;
    HostCnt: TLabel;
    ZoneCnt: TLabel;
    HubCnt: TLabel;
    RegionCnt: TLabel;
    DupeCnt: TLabel;
  Private
    {Insert private declarations here}
  Public
    {Insert public declarations here}
  End;

  TForm1 = Class (TForm)
    PID: TLabel;
    CID: TLabel;
    VID: TLabel;
    Start: TBitBtn;
    ProgressBar: TProgressBar;
    Close1: TBitBtn;
    Panel1: TPanel1;
    LogContainer: TMemo;
    Procedure Form1OnActivate (Sender: TComponent);
    Procedure Form1OnCreate (Sender: TComponent);
    Procedure StartOnClick (Sender: TComponent);
  Private
    {Insert private declarations here}
  Public
    {Insert public declarations here}
  End;

SfNcStat = record
        IndexLen,
        DupeCnt,
        ZoneCnt,
        RegionCnt,
        HostCnt,
        HubCnt :LongInt;
end;

PSfNcStat = ^SfNcStat;

Var
  Form1: TForm1;
  CfgName:string;
  LogText :TMemoStrBuffer;
  imm:Boolean;
  Force:byte;

Implementation

Function DrawLogo(PID,CID,VID:PChar;udp:LongInt):LongInt;cdecl;
begin
  Result := udp;
  Form1.PID.Caption := StrPas(PID);
  Form1.CID.Caption := StrPas(CID);
  Form1.VID.Caption := StrPas(VID);
end;

Function LogLine(str:PChar;udp:LongInt):LongInt;cdecl;
begin
  Result := udp;
  if StrLen(@LogText[0]) > 0 then StrCat(@LogText[0],#10);
  StrCat(@LogText[0],Str);
  Form1.LogContainer.SetText(@LogText[0],StrLen(@LogText[0]));
end;

Function Error(level:LongInt;str:PChar;udp:LongInt):LongInt;cdecl;
begin
  Result := level;
  LogLine(Str,udp);
end;

Function Gauge(perc:LongInt;udp:LongInt):LongInt;cdecl;
begin
  Result := udp;
  Form1.ProgressBar.Position := perc;
end;

Function DrawTotal(Stat:PSfNcStat;udp:LongInt):LongInt;cdecl;
begin
  Result := udp;
  Form1.Panel1.SystemCnt.Caption := IntToStr(Stat^.IndexLen);
  Form1.Panel1.ZoneCnt.Caption := IntToStr(Stat^.ZoneCnt);
  Form1.Panel1.DupeCnt.Caption := IntToStr(Stat^.DupeCnt);
  Form1.Panel1.RegionCnt.Caption := IntToStr(Stat^.RegionCnt);
  Form1.Panel1.HostCnt.Caption := IntToStr(Stat^.HostCnt);
  Form1.Panel1.HubCnt.Caption := IntToStr(Stat^.HubCnt);
end;

Function DrawFinal(etime,stime:single;aspeed,sspeed:LongInt;Stat:PSfNcStat;udp:LongInt):LongInt;cdecl;
begin
  Result := udp;
  DrawTotal(Stat,udp);
end;

Procedure TForm1.Form1OnActivate (Sender: TComponent);
Begin
  if imm then begin
        Show;
        Refresh;
        Start.Click;
        Halt(ExitCode);
//        Close1.Click;
  end
  else Force := 1;
End;

Procedure TForm1.Form1OnCreate (Sender: TComponent);
var
    i:integer;
    label 1;
Begin
  LogText[0] := #0;
  Cfgname := 'sf-nc.cfg';
  Force := 0;
  imm := true;
  if not FileExists('sf-nc.cfg') then
     CfgName := ExtractFilePath(paramStr(0))+'sf-nc.cfg';
     for i:=1 to ParamCount do begin
         if (ParamStr(i)[1] <> '/') and (ParamStr(i)[1] <> '-') then goto 1;
         if Uppercase(ParamStr(i))[2]='C' then CfgName := copy(ParamStr(i),3,4096)
         else if Uppercase(ParamStr(i))[2]='F' then Force:=1
         else if  Uppercase(ParamStr(i))[2]='I' then imm := false
         else begin
1:            MessageBox('usage:'#13'/I - interactive mode'#13'/F - force compile'#13'/C<config-file> - configuration file',[mbOk]);
              Halt(1);
         end;
     end;
End;

Procedure TForm1.StartOnClick (Sender: TComponent);
Begin
        Start.Enabled := false;
        ExitCode := CompileNodelist(@CfgName[1],Force,100,Addr(LogLine),Addr(Error),Addr(Gauge),Addr(DrawTotal),Addr(DrawLogo),nil,Addr(DrawFinal),0);
        Close1.Visible := True;
        Start.Visible := False;
End;

Begin
  RegisterComponents ([TForm1, TLabel, TBitBtn, TProgressBar, TPanel1
   , TPanel, TMemo]);
End.
