#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <limits.h>
#include <stdarg.h>
#include <share.h>
#include <direct.h>
#include <setjmp.h>
#if defined(__OS2__)
#include <os2def.h>
#elif defined(__NT__)
#include <windows.h>
#endif
#include "sf-nc.h"
#include "prodinfo.h"
#include "callback.h"
#include "hptr.h"


unsigned long timeout=0l;
static FILE *handleCfg=NULL;
FILE *handleLog=NULL;
int line = 0;
char token[] = " \t";
char nodepath[128]="";
char logdupes=0;
jmp_buf unwind_buf;

static char *trxphone=NULL;
static unsigned trxlen=0;

static char *S_uptodate = "nodelist index is up-to-date";
static SectionReached=0;

extern "C"{
#if defined(__OS2__) || defined(__NT__)
    _CALLBACK (*_cLogLine)(char *str,long)=NULL;
    _CALLBACK (*_cError)(int level,char *str,int line,long)=NULL;
    _CALLBACK (*_cGauge)(int perc,long)=NULL;
    _CALLBACK (*_cDrawTotal)(SfNcStat *pStat,long)=NULL;
    _CALLBACK (*_cDrawLogo)(char *__PID__, char *__CID__, char *__VID__,long)=NULL;
    _CALLBACK (*_cDrawScreen)(long)=NULL;
    _CALLBACK (*_cDrawFinal)(float etime,float stime,long aspeed,long sspeed,SfNcStat *pStat,long UDP)=NULL;
#endif
    long _UDP;
}

static char *readCfgLine( char *command );
static void comerr(char *command);

static void startlog(void)
{
    plog("\b!");
    plog("\b%s",__PID__);
    plog("\b%s",__CID__);
    plog("\b%s",__VID__);
    plog("\b");
    plog("logging started");
}

static void WriteTrx(void)
{
    FILE* handle;
    unsigned long trycnt;
    unsigned long tmout;
    char outfile[128];

    strcpy( outfile, nodepath );
    strcat( outfile, "ADPHONE.TRX" );
    plog( "writing phone translation table" );
    tmout=timeout+(trycnt=clock());
    for( ; trycnt<=tmout; trycnt=clock() ){
        handle = _fsopen( outfile,"wb",SH_DENYRW );
        if( handle )break;
        else if(!timeout)break;
    }
    if( !handle ){
        error( 5, "cannot create %.100s: %s", outfile, strerror(errno) );
    }
    if( write( fileno(handle), trxphone, trxlen ) == -1 ){
        fclose(handle);
        error( 5, "error writing %.100s: %s", outfile, strerror(errno) );
    }
    fclose(handle);
    chmod( outfile, S_IWRITE );
    free(trxphone);
    trxphone=NULL;
}

static void cleanup(void)
{
    if(trxphone)free(trxphone);
    if(index)
#if !defined(__386__)
    huge_realloc(index,0);
#else
    free(index);
#endif
    if(handleCfg)fclose(handleCfg);
    if(handleLog)fclose(handleLog);
    if(handleNdl)fclose(handleNdl);
}

extern "C"{
#if defined(__OS2__)
APIRET APIENTRY
#elif defined(__NT__)
int __syscall
#else
int
#endif
CompileNodelist( char *config, char force, short _GaugeLen,
                _CALLBACK (*_cpLogLine)(char *str,long),
                _CALLBACK (*_cpError)(int level,char *str,int line,long),
                _CALLBACK (*_cpGauge)(int perc,long),
                _CALLBACK (*_cpDrawTotal)(SfNcStat *pStat,long),
                _CALLBACK (*_cpDrawLogo)(char *__PID__, char *__CID__, char *__VID__,long),
                _CALLBACK (*_cpDrawScreen)(long),
                _CALLBACK (*_cpDrawFinal)(float etime,float stime,long aspeed,long sspeed,SfNcStat *pStat,long UDP),
                long pUDP )
{
    clock_t start, startSort;
    char command[128];
    int i;

    _cLogLine   = _cpLogLine;
    _cError     = _cpError;
    _cGauge     = _cpGauge;
    _cDrawTotal = _cpDrawTotal;
    _cDrawLogo  = _cpDrawLogo;
    _cDrawScreen= _cpDrawScreen;
    _cDrawFinal = _cpDrawFinal;
    _UDP = pUDP;
    GAUGE_LEN = _GaugeLen;

    i=setjmp(unwind_buf);
    if(i){
        cleanup();
        return i<0?0:i;
    }
    drawLogo(__PID__,__CID__,__VID__);
    handleCfg = _fsopen( config, "r", SH_DENYWR );
    if( !handleCfg ){
        error( 1, "cannot open configuration file %s: %s", config, strerror(errno) );
    }
    drawScreen();
    plog( "reading configuration file %s", config );
    memset( command, 0, 128 );

    start = clock();

    while( readCfgLine( command ) ){
        char *keyword;
        char *value;
        char *rest;

        keyword = strtok( command, token );
        if( keyword ){
            if( !strcmp( "TRXPHONE", keyword ) ){
                if(trxlen)error(2,"double defined phone translation table");
                while( readCfgLine( command ) ){
                    keyword = strtok( command, token );
                    if( keyword ){
                        if( !strcmp( "END", keyword ) )goto NextLoop;
                        trxphone = (char*)realloc(trxphone,trxlen+0x22);
                        memset( &trxphone[trxlen], 0, 0x22 );
                        trxphone[trxlen] = (char)strlen( keyword );
                        if( trxphone[trxlen] > 0x0F )
                            error( 2, "maximum nodelist phone prefix length is 15" );
                        memcpy( &trxphone[trxlen+1], keyword, trxphone[trxlen] );
                        keyword = strtok( NULL, token );
                        if( keyword ){
                            trxphone[trxlen+0x10] = (char)strlen( keyword );
                            if( trxphone[trxlen+0x10] > 0x11 )
                                error( 2, "maximum translated phone prefix length is 17" );
                            memcpy( &trxphone[trxlen+0x11], keyword, trxphone[trxlen+0x10] );
                        }
                        trxlen += 0x22;
                    }
                }
                error( 2, "unclosed trxphone table" );
            }
            value = strtok( NULL, token );
            if( !value )comerr(command);
            rest = strtok( NULL, "\n" );
            if( !strcmp( "INDEXRETRY", keyword ) ){
                if( rest )comerr(command);
                timeout = atol(value);
                continue;
            }
            if( !strcmp( "NODEPATH", keyword ) ){
                if( rest )comerr(command);
                strcpy( nodepath, value );
                i = strlen( nodepath )-1;
                if( nodepath[i] != '\\' ){
                    nodepath[++i] = '\\';
                    nodepath[++i] = 0;
                }
                continue;
            }
            if( !strcmp( "LOG", keyword ) ){
                if( rest || handleLog )comerr(command);
                handleLog=_fsopen(value,"a",SH_DENYRD);
                if(!handleLog)plog("cannot open log file %s",value);
                else startlog();
                continue;
            }
            if( !strcmp( "LOGDUPES", keyword ) ){
                if( rest )comerr(command);
                if(!strcmp(value,"YES")){
                    logdupes=1;
                    continue;
                }
                if(!strcmp(value,"NO")){
                    logdupes=0;
                    continue;
                }
                comerr(command);
            }
            if( !strcmp( "NODELIST", keyword ) ){
                processList( LT_NODELIST, value, rest );
                continue;
            }
            if( !strcmp( "POINTLIST", keyword ) ){
                processList( LT_POINTLIST, value, rest );
                continue;
            }
            error( 2, "unrecognized keyword %s", keyword );
        }
NextLoop: continue;
    }
    fclose( handleCfg );
    handleCfg = NULL;
    if( !SectionReached )error( 2, "cannot find [Nodelist] section in config file" );
    if( !ListCnt )error( 2, "nothing to do" );
    if( !trxlen )error( 2, "no TrxPhone-table");
    if( GetNames() ){
        if( force )plog( "%s, compilation forced", S_uptodate );
        else error( 0, S_uptodate );
    }
    WriteTrx();
    CollectNdl();
    startSort = clock();
    indexSort();
    startSort = clock()-startSort;
    writeOut();
    start = clock()-start;
    plog( "all done" );
    drawFinal(((float)start)/CLOCKS_PER_SEC,
              ((float)startSort)/CLOCKS_PER_SEC,
              start?Stat.indexlen*CLOCKS_PER_SEC/start:LONG_MAX,
              startSort?Stat.indexlen*CLOCKS_PER_SEC/startSort:LONG_MAX );
    cleanup();
    return 0;
}
}

static void comerr(char *command)
{
    error( 2, "invalid command %s", command );
}

static char *readAnyCfgLine( char *command )
{
    char *p;

    if( fgets( command, 128, handleCfg ) ){
        line++;
        p = strchr( command, '\n' );
        if( p )*p = 0;
        p = strchr( command, '\r' );
        if( p )*p = 0;
        p = strchr( command, ';' );
        if( p ){
            *p=0;
        }else{
            p = command + strlen( command );
        }
        while( strchr( token, *--p ) )*p=0;
//        while( *command == ' ' )command++;
        return strupr(command);
    }
    return NULL;
}

static char *readCfgLine( char *command )
{
    char *p;

    if( SectionReached==2 )return NULL;
    while( (p=readAnyCfgLine( command ))!=NULL ){
        if( !*p )continue;
        while( strchr( token, *p ) )p++;
        if( !SectionReached ){
            if( !strcmp( p, "[NODELIST]" ) )SectionReached=1;
        }else{
            if( *p=='[' ){
                SectionReached=2;
                return NULL;
            }else return command;
        }
    }
    return NULL;
}
