#ifndef __SFNC_H__
#define __SFNC_H__

#include <stdio.h>
#include <setjmp.h>
#include "ndl.h"
#include "sfncstat.h"

#ifdef __cplusplus
extern "C"{
#endif
extern short GAUGE_LEN;
#ifdef __cplusplus
}
#endif

#define LT_NODELIST         1
#define LT_POINTLIST        2
#if defined(__386__)
    #define HEAP_GRANULARITY    4096
#else
    #define HEAP_GRANULARITY    64
#endif

#define M_ZONE              ((unsigned long)0x80000000)
#define M_HOST              ((unsigned long)0xC0000000)
#define M_REGION            ((unsigned long)0x40000000)
#define M_HUB               ((unsigned long)0x20000000)
#define M_CLEAR             ((unsigned long)0x1FFFFFFF)

#define C_ZONE              0x80
#define C_HOST              0xC0
#define C_REGION            0x40
#define C_HUB               0x20
#define C_CLEAR             0x1F

typedef union{
    tAddress    Bin;
    char        Pattern[28];
}tAddressMaskTemplate;

typedef struct{
    tAddressMaskTemplate Mask;
    char                 Masked;
}tAddressMask;

#define MAX_INCEXC 8

typedef struct{
    tAddressMask  ExcludeList[MAX_INCEXC];
    tAddressMask  IncludeList[MAX_INCEXC];
    int           CfgLine;
    short         DefZone;
    short         DefNet;
    short         DefRegion;
    char          Type;
    char          ExcludeCnt;
    char          IncludeCnt;
    char          Masked;
    char          Crc;
    char          Name[13];
}tNdlInfo;

void processList( char type, char *fnm, char *qual );
int GetNames(void);
void CollectNdl(void);
void collectRec( unsigned char NdlNo );
void getLast( char *fnm );
void indexSort(void);
void checkDupes(void);
void writeOut( void );
void gaugePos(int);
void plog( char *format, ... );
void error( int level, char *format, ... );
void drawTotal(void);
void drawLogo(char *__PID__, char *__CID__, char *__VID__);
void drawScreen(void);
void drawFinal(float etime,float stime,long aspeed,long sspeed);

extern int line;
extern char nodepath[128];
extern char token[];
extern tNodeIdxRec *index;
extern tNodeHdrRec Header[ MAX_NODE_HDR ];
extern int ListCnt;
extern unsigned long timeout;
extern FILE *handleLog;
extern char logdupes;
extern jmp_buf unwind_buf;
extern FILE *handleNdl;

extern tNdlInfo NdlInfo[MAX_NODE_HDR];
                         
#endif
