#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "sf-nc.h"
#include "ndl.h"
#include "hptr.h"

int cmpAddress( const void *p1, const void *p2 );

static long tosort;
static long step;
static long curstep=0l;
static int compar=0;

#if !defined(__386__)
    #define qsort huge_qsort
#endif

void indexSort(void)
{
    plog( "sorting index" );
    tosort = Stat.indexlen * (((long)log(Stat.indexlen))<<1);
    step=tosort/GAUGE_LEN;
    gaugePos(0);
    qsort( (char*)index, Stat.indexlen, sizeof(tNodeIdxRec), cmpAddress );
    gaugePos(0);
}

int cmpAddress( const void *p1, const void *p2 )
{
    if(++curstep == step){
        gaugePos( ++compar );
        curstep=0;
    }

#if !defined(__386__)
    p1 = farptr_norm( (void *)p1 );
    p2 = farptr_norm( (void *)p2 );
#endif

    if( *(tAddress*)p1 == *(tAddress*)p2 ){
        int res;

#if defined(__386__)
        if( p1 == p2 )return 0;
#else
        if( hptr_diff( (char far*)p1, (char far*)p2 ) == 0 )return 0;
#endif
        if( ((tNodeIdxRec*)p1)->NdlNo > ((tNodeIdxRec*)p2)->NdlNo ){
            ((tNodeIdxRec*)p2)->NdlNo = 0;
            return -1;
        }
        if( ((tNodeIdxRec*)p1)->NdlNo < ((tNodeIdxRec*)p2)->NdlNo ){
            ((tNodeIdxRec*)p1)->NdlNo = 0;
            return  1;
        }
        res = ((((tNodeIdxRec*)p1)->NdlOfs & M_CLEAR) < (((tNodeIdxRec*)p2)->NdlOfs & M_CLEAR));
        if( res > 0 )((tNodeIdxRec*)p1)->NdlNo = 0;
        else ((tNodeIdxRec*)p2)->NdlNo = 0;
        return res;
    }
    if( *(tAddress*)p1 <  *(tAddress*)p2 )return -1;
    return 1;
}

