unit Interfce;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls;

function CompileNodelist(config:PChar;force:byte;gaugeLen:Word;LogLine,Error,Gauge,DrawTotal,DrawLogo,DrawScreen,DrawFinal:Pointer;UDP:LongInt):LongInt;
         cdecl;external 'sf-ncw32.dll' name 'CompileNodelist';

const clsCap = '&Close';

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PID: TLabel;
    CID: TLabel;
    VID: TLabel;
    LogContainer: TMemo;
    Panel2: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Cnt1: TLabel;
    Cnt2: TLabel;
    Cnt3: TLabel;
    Cnt4: TLabel;
    Cnt5: TLabel;
    Cnt6: TLabel;
    Panel3: TPanel;
    ProgressBar: TProgressBar;
    Panel4: TPanel;
    Start: TBitBtn;
    Close1: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Close1Click(Sender: TObject);
  private
    { Private declarations }
    FileName:string;
    Force:Byte;
    imm:Boolean;
  public
    { Public declarations }
  end;

SfNcStat = record
         IndexLen,
         DupeCnt,
         ZoneCnt,
         RegionCnt,
         HostCnt,
         HubCnt :LongInt;
end;

PSfNcStat = ^SfNcStat;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function LogLine(str:PChar;udp:LongInt):Integer;cdecl;
begin
     Application.ProcessMessages;
     Form1.LogContainer.Lines.Add(str);
     Result := 0;
end;

function Error(level:integer;str:PChar;line:integer;udp:LongInt):Integer;cdecl;
begin
     Application.ProcessMessages;
     Form1.LogContainer.Lines.Add(str);
     if level <> 0 then Application.MessageBox(str,PChar(Application.Title),MB_APPLMODAL+MB_ICONERROR);
     Result := 0;
end;

function Gauge(perc:integer;udp:LongInt):Integer;cdecl;
begin
     Application.ProcessMessages;
     Form1.ProgressBar.Position := perc;
     Result := 0;
end;

function DrawLogo(PID,CID,VID:PChar;udp:LongInt):Integer;cdecl;
begin
     Application.ProcessMessages;
     Form1.PID.Caption := PID;
     Form1.CID.Caption := CID;
     Form1.VID.Caption := VID;
     Result := 0;
end;

function DrawTotal(Stat:PSfNcStat;udp:LongInt):Integer;cdecl;
begin
     Application.ProcessMessages;
     Form1.Cnt1.Caption := IntToStr(Stat^.IndexLen);
     Form1.Cnt2.Caption := IntToStr(Stat^.ZoneCnt);
     Form1.Cnt3.Caption := IntToStr(Stat^.RegionCnt);
     Form1.Cnt4.Caption := IntToStr(Stat^.HostCnt);
     Form1.Cnt5.Caption := IntToStr(Stat^.HubCnt);
     Form1.Cnt6.Caption := IntToStr(Stat^.DupeCnt);
     Result := 0;
end;

function DrawFinal(etime,stime:Single;aspeed,sspeed:LongInt;Stat:PSfNcStat;udp:LongInt):Integer;cdecl;
begin
     Application.ProcessMessages;
     DrawTotal(Stat,udp);
     Result := 0;
end;

procedure TForm1.FormActivate(Sender: TObject);
var
    i:integer;
    label 1;
begin
     if Force <> $FF then exit;
     Filename := 'sf-nc.cfg';
     Force := 0;
     imm := true;
     if not FileExists('sf-nc.cfg') then
     FileName := ExtractFilePath(Application.ExeName)+'sf-nc.cfg';
     for i:=1 to ParamCount do begin
         if (ParamStr(i)[1] <> '/') and (ParamStr(i)[1] <> '-') then goto 1;
         if Uppercase(ParamStr(i))[2]='C' then FileName := copy(ParamStr(i),3,4096)
         else if Uppercase(ParamStr(i))[2]='F' then Force:=1
         else if  Uppercase(ParamStr(i))[2]='I' then imm := false
         else begin
1:            Application.MessageBox(PChar('usage:'#10#13'/I - interactive mode'#10#13'/F - force compile'#10#13'/C<config-file> - configuration file'),PChar(Application.Title),MB_APPLMODAL{+MB_ICONERROR});
              Close;
         end;
     end;
     if imm then Start.Click
     else Force := 1;
end;

procedure TForm1.StartClick(Sender: TObject);
begin
     Start.Enabled := false;
     ExitCode := CompileNodelist(PChar(FileName),Force,100,Addr(LogLine),Addr(Error),Addr(Gauge),Addr(DrawTotal),Addr(DrawLogo),nil,Addr(DrawFinal),0);
     if Imm then Close
     else begin
          Close1.Visible := true;
          Start.Visible := false;
     end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     Force := $FF;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
     Close;
end;

end.
