#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <string.h>
#include <time.h>
#include <share.h>
#include "sf-nc.h"
#include "ndl.h"
#include "hptr.h"

static unsigned int BLOCK=
#if defined(__386__)
    (0xFFFF/sizeof(tNodeIdxRec));
    #define element(member) (index[i+j].member)
#else
    (0x4FFF/sizeof(tNodeIdxRec));
    #define element(member) (((tNodeIdxRec*)hptr_add( index, (i+j) ))->member)
#endif

static long step;
static long curstep=0l;
static int gstep=0;

void writeOut( void )
{

    FILE* handle;
    long i;
    int j;
    char eflag;
    char indexname[128];
    tNodeIdxHdr Hdr;
    unsigned long trycnt,tmout;


    strcpy( indexname, nodepath );
    strcat( indexname, "ADNDL.IDX" );
    plog( "writing index file %s", indexname );
    gaugePos(0);
    tmout=timeout+(trycnt=clock());
    for( ; trycnt<=tmout; trycnt=clock() ){
        handle = _fsopen( indexname, "wb", SH_DENYRW );
        if( handle )break;
        else if(!timeout)break;
    }
    if( !handle ){
        error( 5, timeout?"cannot create index, timeout expired: %s":
                          "cannot create index: %s", strerror(errno) );
    }
    Hdr.TotalNdls = (unsigned char)ListCnt;
    Hdr.Size = ListCnt*sizeof(tNodeHdrRec)+sizeof( Hdr );
    write( fileno(handle), &Hdr, sizeof( Hdr ) );
    write( fileno(handle), Header, ListCnt*sizeof(tNodeHdrRec) );

    step = Stat.indexlen/GAUGE_LEN;

    for( i = 0; i < Stat.indexlen; i+=j ){
        for( eflag = 0, j = 0; j < BLOCK; j++ ){
            if(++curstep == step){
                gaugePos( ++gstep );
                curstep=0;
            }
//            gaugePos( (int)((i+j)*GAUGE_LEN/indexlen) );
            if( i+j == Stat.indexlen )break;
            if( element( NdlNo ) == 0 ){
                Stat.DupeCnt++;
                if(logdupes)plog("warned duplicate node %d:%d/%d.%d",
                    element( Address.Zone ),
                    element( Address.Net ),
                    element( Address.Node ),
                    element( Address.Point )
                    );
                switch( ( element( NdlOfs ) >> 24 ) & ~C_CLEAR ){
                    case C_ZONE:    Stat.ZoneCnt--;
                                    break;
                    case C_REGION:  Stat.RegionCnt--;
                                    break;
                    case C_HOST:    Stat.HostCnt--;
                                    break;
                    case C_HUB:     Stat.HubCnt--;
                                    break;
                }
                drawTotal();
                eflag++;
                break;
            }
            element( NdlOfs ) &= M_CLEAR;
        }
        if( j ){
            if( write( fileno(handle), hptr_add( index, i ), j*sizeof(tNodeIdxRec) ) == -1 ){
                fclose(handle);
                error( 5, "error writing index: %s", strerror(errno) );
            }
        }
        if( eflag )j++;
    }
//    gaugePos(GAUGE_LEN);
    fclose( handle );
    chmod( indexname, S_IWRITE );
//    gaugeOff();
}
