#ifndef _KEY_DEF_INT_
#define _KEY_DEF_INT_

// 8 bit codes

#define BackSpace       0x08
#define Tab             0x09
#define Enter           0x0D
#define CtrlEnter       0x0A
#define Esc             0x1B
#define Blank           0x20

// 16 bit codes

#define Home            0x147
#define Up              0x148
#define PgUp            0x149
#define Left            0x14B
#define Right           0x14D
#define End             0x14F
#define Down            0x150
#define PgDown          0x151
#define Ins             0x152
#define Del             0x153
#define CtrlEnd   	0x175
#define CtrlPgDown      0x176
#define CtrlHome        0x177
#define Alt1            0x178
#define Alt2            0x179
#define Alt3            0x17A
#define Alt4         379     // Alt-4
#define Alt5         380     // Alt-5
#define Alt6         381     // Alt-6
#define Alt7         382     // Alt-7
#define Alt8         383     // Alt-8
#define Alt9         384     // Alt-9
#define Alt0         385     // Alt-0
#define CtrlPgUp        0x184

#define F1		0x13B
#define F2		0x13C
#define F3		0x13D
#define F4		0x13E
#define F5		0x13F
#define F6		0x140
#define F7		0x141
#define F8		0x142
#define F9		0x143
#define F10		0x144

#define ShiftF1		0x154
#define ShiftF2		0x155
#define ShiftF3		0x156
#define ShiftF4		0x157
#define ShiftF5		0x158
#define ShiftF6		0x159
#define ShiftF7		0x15A
#define ShiftF8		0x15B
#define ShiftF9		0x15C
#define ShiftF10    0x15D

#define CtrlF1		0x15E
#define CtrlF2		0x15F
#define CtrlF3		0x160
#define CtrlF4		0x161
#define CtrlF5		0x162
#define CtrlF6		0x163
#define CtrlF7		0x164
#define CtrlF8		0x165
#define CtrlF9		0x166
#define CtrlF10		0x167

#define AltF1		0x168
#define AltF2		0x169
#define AltF3		0x16A
#define AltF4		0x16B
#define AltF5		0x16C
#define AltF6		0x16D
#define AltF7		0x16E
#define AltF8		0x16F
#define AltF9		0x170
#define AltF10		0x171


#define AltA         286     // Alt-A
#define AltB         304     // Alt-B
#define AltC         302     // Alt-C
#define AltD         288     // Alt-D
#define AltE         274     // Alt-E
#define AltF         289     // Alt-F
#define AltG         290     // Alt-G
#define AltH         291     // Alt-H
#define AltI         279     // Alt-I
#define AltJ         292     // Alt-J
#define AltK         293     // Alt-K
#define AltL         294     // Alt-L
#define AltM         306     // Alt-M
#define AltN         305     // Alt-N
#define AltO         280     // Alt-O
#define AltP         281     // Alt-P
#define AltQ         272     // Alt-Q
#define AltR         275     // Alt-R
#define AltS         287     // Alt-S
#define AltT         276     // Alt-T
#define AltU         278     // Alt-U
#define AltV         303     // Alt-V
#define AltW         273     // Alt-W
#define AltX         301     // Alt-X
#define AltY         277     // Alt-Y
#define AltZ         300     // Alt-Z


// mouse codes

#define LMB		0x201
#define MMB		0x202
#define RMB		0x203

#define dblLMB  0x211
#define dblMMB  0x212
#define dblRMB  0x213

#define CQuit   0x220       // special 'Quit' message
#define CInvalidate 0x221   // special 'Invalidate'

#endif
