            .XLIST
INCLUDE     lexical.inc
            .XLIST
            .SFCOND
            .XALL
INCLUDE     model.inc

CHKDef      =         0

LexDef      MACRO
            TITLE     Lexical module compiler, (c) Stanislav V. Meckhanoshin, 1995
            IF1
            %OUT      Lexical module compiler, (c) Stanislav V. Meckhanoshin, 1995
            ENDIF
DGROUP      GROUP     _LEXDEFSEG
_LEXDEFSEG  segment   para public 'DATA'
CHKDef      =         1
            ENDM

LexEnd      MACRO
            dw        0
_LEXDEFSEG  ends
            IFNDEF    StateCnt
                      .ERR
                      %OUT  Error: Syntax not defined
            ENDIF
            IF        StateCnt  EQ  0
                      .ERR
                      %OUT  Error: No one state was defined
            ENDIF
            end
            ENDM

Routine     MACRO     name
            IF        CHKDef    EQ  1
                      .ERR
                      %OUT  Error: You must declare external '&name' before call to 'lexdef'
            ELSE
                      IFDEF     I8086L
                          EXTRN     _&name:FAR
                      ENDIF
                      IFDEF     I8086S
                          EXTRN     _&name:NEAR
                      ENDIF
                      IFDEF     I8086C
                          EXTRN     _&name:NEAR
                      ENDIF
                      IFDEF     I8086M
                          EXTRN     _&name:FAR
                      ENDIF
            ENDIF
            ENDM

State       MACRO     name
            IFNDEF    CHKSyntax
                      .ERR
                      %OUT  Error: Syntax not yet defined at state '&name'
            ENDIF
            IFDEF     CHKState
                      IF  CHKState  EQ  1
                          .ERR
                          %OUT  Error: You must define at least one TRANslation to state '&name'
                      ENDIF
            ENDIF
name        db        0
CHKState    =         1
StateCnt    =         StateCnt  + 1
            ENDM

Syntax      MACRO     name
            IF1
            %OUT      Compiling syntax '&name'
            ENDIF
StateCnt    =         0
            PUBLIC    _&name
_&name      db        0
CHKSyntax   =         0
CHKState    =         0
            ENDM

Tran        MACRO     key, target, routine
            IFNDEF    CHKState
                      .ERR
                      %OUT  Error: You must define Syntax first
            ELSE
                      IF  CHKState  EQ  0
                          .ERR
                          %OUT  Error: TRANslation without state
                      ENDIF
            ENDIF
CHKState    =         2
            db        key
            IFDEF   DOS386
                    dd      target
            ELSE
                    IFDEF   I8086L
                            dd      target
                    ENDIF
                    IFDEF   I8086M
                            dw      target
                    ENDIF
                    IFDEF   I8086S
                            dw      target
                    ENDIF
                    IFDEF   I8086C
                            dd      target
                    ENDIF
            ENDIF
            IFNB      <routine>
                      IFDEF DOS386
                              dd      _&routine
                      ELSE
                              IFDEF   I8086L
                                      dd      _&routine
                              ENDIF
                              IFDEF   I8086M
                                      dd      _&routine
                              ENDIF
                              IFDEF   I8086S
                                      dw      _&routine
                              ENDIF
                              IFDEF   I8086C
                                      dw      _&routine
                              ENDIF
                      ENDIF
            ELSE
                      IFDEF DOS386
                              dd      0
                      ELSE
                              IFDEF   I8086L
                                      dd      0
                              ENDIF
                              IFDEF   I8086M
                                      dd      0
                              ENDIF
                              IFDEF   I8086S
                                      dw      0
                              ENDIF
                              IFDEF   I8086C
                                      dw      0
                              ENDIF
                      ENDIF
            ENDIF
            ENDM

TranKeyword MACRO     key, target, routine
            Tran      LEX_KEYWORD, target, routine
            db        key
            db        0
            ENDM

TranNumber  MACRO     radix, target, routine
            Tran      LEX_NUMBER, target, routine
            IFNB      <radix>
                      db        radix
            ELSE
                      db        10
            ENDIF
            ENDM

TranSyntax  MACRO     syntax, target, routine
            Tran      LEX_SUBSYNTAX, target, routine
            IFDEF     DOS386
                      dd    far ptr _&syntax
            ELSE
                      IFDEF     I8086L
                                dd    far ptr _&syntax
                      ENDIF
                      IFDEF     I8086S
                                dw    near ptr _&syntax
                      ENDIF
                      IFDEF     I8086C
                                dd    far ptr _&syntax
                      ENDIF
                      IFDEF     I8086M
                                dw    near ptr _&syntax
                      ENDIF
            ENDIF
            ENDM

            .LIST
