#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include <time.h>
#include <stdlib.h>
#include <bios.h>
#include <limits.h>
#include "tscreen.h"
#include "key.h"
#include "ncview.h"
#include "slice.h"
#include "mouse.h"

void screenSaver();

extern "C" {

typedef struct keypressEvent_{
  int key;
  int x, y;
  int mouseMask;
  keypressEvent_ *next;
}keypressStack;

int mouseX, mouseY;

void (*onkey)(int);

static keypressStack *keypressHead;
static keypressStack *keypressPtr;

static char update = 0;
static char disabled = 0;
static int x ,y;
static clock_t oclock;

int idleTime;
int idleMax;

void mouseEventHandler();

void enableMouse()
{
  REGS regs;

  if( update || Screen.maxCol > 80 )return;

  regs.x.ax = 1;
  int86( 0x33, &regs, &regs );
  disabled = 0;
}

void disableMouse()
{
  REGS regs;

  if( update )return;

  regs.x.ax = 2;
  int86( 0x33, &regs, &regs );
  disabled = 1;
}

void resetMouse()
{
  REGS regs;

  int maxX = (Screen.maxCol-1)<<3;
  int maxY = (Screen.maxRow-1)<<3;

  if( Screen.maxCol > 80 ){
    disableMouse();
    return;
  }
  regs.x.ax = 0;
  int86( 0x33, &regs, &regs );
  regs.x.ax = 7;
  regs.x.cx = 0;
  regs.x.dx = maxX;
  int86( 0x33, &regs, &regs );
  regs.x.ax = 8;
  regs.x.cx = 0;
  regs.x.dx = maxY;
  int86( 0x33, &regs, &regs );
}

void mouseLongUpdate()
{
  disableMouse();
  update = 1;
}

void mouseEndUpdate()
{
  update = 0;
  enableMouse();
}

void initMouse()
{
  if( NC_Color() == -1 )resetMouse();
  enableMouse();
  keypressHead = keypressPtr = NULL;
  mouseX = mouseY = 0;
  sliceCritical = 0;
  idleMax = 60;
  idleTime = 0;
  oclock = 0;
  onkey = 0;
}

int inkey()
{
  int i;

  i = getch();
  if( !i )i = 0x100 | getch();
  return i;
}

int __mkbhit()
{
 int button, flag;
 REGS regs;

 if( !oclock )oclock=clock()/CLK_TCK;
 else idleTime = (int)(clock()/CLK_TCK - oclock);

 if( keypressHead ){
    oclock=clock()/CLK_TCK;
    idleTime = 0;
    return keypressHead->key;
 }
 if( kbhit() ){
   keypressHead = new keypressStack;
   keypressPtr = keypressHead;
   keypressPtr->next = NULL;
   keypressPtr->key = inkey();
   keypressPtr->x = 0;
   keypressPtr->y = 0;
   keypressPtr->mouseMask = 0;
   oclock=clock()/CLK_TCK;
   idleTime = 0;
   return keypressHead->key;
 }else{
   regs.x.bx = 0;
   regs.x.ax = 3;
   int86( 0x33, &regs, &regs );
   button = regs.x.bx;
   x = regs.x.cx;
   y = regs.x.dx;

   if( button & 7 ){
     keypressHead = new keypressStack;
     keypressPtr = keypressHead;
     keypressPtr->next = NULL;
     keypressPtr->mouseMask = button;
     keypressPtr->key = ( button & 1 )?LMB:(( button & 2 )?RMB:MMB);
     keypressPtr->x = ( x>>3 )+1;
     keypressPtr->y = ( y>>3 )+1;

//   check for double clicking...

     flag = 0;
Again_release:
     delay( 3 );
     regs.x.bx = 0;
     regs.x.ax = 3;
     int86( 0x33, &regs, &regs );
     button = regs.x.bx;
     if( button&7 ){
        if( flag<12 ){
            flag++;
            goto Again_release;
        }else goto Ret;
     }
     flag = 0;
Again_press:
     delay( 10 );
     regs.x.bx = 0;
     regs.x.ax = 3;
     int86( 0x33, &regs, &regs );
     button = regs.x.bx;
     if( !(button&7) ){
        if( flag < 10 ){
            flag++;
            goto Again_press;
        }else goto Ret;
     }
     if( x != regs.x.cx || y != regs.x.dx )goto Ret;

     switch( keypressPtr->key ){
        case LMB:
            if( button&1 )keypressPtr->key = dblLMB;
            break;
        case MMB:
            if( button&4 )keypressPtr->key = dblMMB;
            break;
        case RMB:
            if( button&2 )keypressPtr->key = dblRMB;
            break;
     }

//   end check

Ret:

     oclock=clock()/CLK_TCK;
     idleTime = 0;
     return keypressHead->key;
   }
 }
// if( (!disabled) && (!mouseStatus()) )if( (mouseX==80) && (mouseY==1) )goto Save;
 if( !idleMax )goto ZERO;
 if( idleTime >= idleMax ){
    button = idleMax;
    idleMax = 0;
    screenSaver();
    idleMax = button;
    idleTime = 0;
    oclock=clock()/CLK_TCK;
    return __mkbhit();
 }
 else goto ZERO;
ZERO:
    releaseSlice();
    return 0;
}

static char insideOnKey = 0;

int mkbhit()
{
    int i= __mkbhit();

    if( i && !insideOnKey ){
        if( onkey ){
            insideOnKey = 1;
            (*onkey)( i );
            insideOnKey = 0;
        }
        return __mkbhit();
    }
    return i;
}

int mgetch()
{
  int key;
  keypressStack *ptr;

  while( !mkbhit() )continue;
  key = keypressHead->key;
  if( keypressHead->mouseMask ){
    mouseX = keypressHead->x;
    mouseY = keypressHead->y;
  }
  ptr = keypressHead->next;
  delete keypressHead;
  keypressHead = ptr;
/*
  ptr = keypressHead;
  keypressHead = keypressHead->next;
  delete ptr;
*/
  return key;
}

void mungetch( int key )
{
  if( !keypressHead ){
    keypressHead = keypressPtr = new keypressStack;
  }else{
    keypressPtr->next = new keypressStack;
    keypressPtr = keypressPtr->next;
  }
  keypressPtr->next = NULL;
  keypressPtr->key = key;
  keypressPtr->x   = mouseX;
  keypressPtr->y   = mouseY;
}

int mouseStatus()
{
   REGS regs;

   regs.x.bx = 0;
   regs.x.ax = 3;
   int86( 0x33, &regs, &regs );
   x = regs.x.bx;
   mouseX = regs.x.cx>>3;
   mouseY = regs.x.dx>>3;
   mouseX++;
   mouseY++;
   return x;
}

int mousekeyBar()
{
  if( mouseY != Screen.maxRow )return 0;
  mungetch( ((mouseX-1)>>3)+F1 );
  return 1;
}

void mouseWaitRelease()
{
    unsigned char oldsym;
    int i, d;

    i = mouseX;
    d = mouseY;
    oldsym = Screen.screenAddr[ ((d-1)*Screen.maxCol + i-1)<<1 ];
    if( mouseStatus() ){
        disableMouse();
        Screen.screenAddr[ ((d-1)*Screen.maxCol + (i-1))<<1 ] = '';
        enableMouse();
    }
    while( mouseStatus() );
    disableMouse();
    Screen.screenAddr[ ((d-1)*Screen.maxCol + (i-1))<<1 ] = oldsym;
    enableMouse();
    mouseX = i;
    mouseY = d;
}

/*
void releaseSlice()
{
    REGS regs;

    if( sliceCritical )return;

    regs.x.ax = 0x1680;
    int86( 0x2F, &regs, &regs );
    if( !regs.h.al )return;
    regs.x.ax = 0x1000;
    int86( 0x15, &regs, &regs );
    int86( 0x28, &regs, &regs );
    return;
}
*/

int shiftState()
{
    if( mkbhit() )return 0;
    return
#ifdef __WATCOMC__
        _bios_keybrd(_KEYBRD_SHIFTSTATUS)
#else
        bioskey(2)
#endif
    ;
}

void SetMouseXY( int x, int y )
{
    REGS regs;

    mouseX = (x-1)<<3;
    mouseY = (y-1)<<3;
    regs.x.ax = 0x4;
    regs.x.cx = mouseX;
    regs.x.dx = mouseY;
    int86( 0x33, &regs, &regs );
}

void forceScrSave()
{
    while( mkbhit() )mgetch();
    oclock = 0;
    idleTime = INT_MAX;
}
}
