#include <ctype.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <signal.h>
#include <share.h>
#include <sys\stat.h>
#include "lexical.h"
#include "ndl.h"
#include "view.h"
#include "key.h"
#include "mouse.h"
#include "tstatus.h"
#include "sf-node.h"
#include "selexpr.h"
#include "country.h"
#include "slice.h"

/*
#if defined(__COMPACT__) || defined(__LARGE__) || defined(__HUGE__)
extern "C" {
#if defined(__ZTC__)
int _stack = 0x8000;
#elif defined(__WATCOMC__)
unsigned int _stacksize = 0x8000;
#endif
}
#endif
*/

LEX_DECLARE_SYNTAX( CONFIG )
LEX_DECLARE_SYNTAX( ADDRESS )
LEX_DECLARE_SYNTAX( MEMORY )
LEX_DECLARE_ROUTINE( GET_NDL )
LEX_DECLARE_ROUTINE( GET_TIMEOUT )
LEX_DECLARE_ROUTINE( STYPE )
LEX_DECLARE_ROUTINE( GETUTC )
LEX_DECLARE_ROUTINE( GETSZONE )
LEX_DECLARE_ROUTINE( GETSNET )
LEX_DECLARE_ROUTINE( GETSNODE )
LEX_DECLARE_ROUTINE( GETSPOINT )
LEX_DECLARE_ROUTINE( GETSEL )
LEX_DECLARE_ROUTINE( PREAND )
LEX_DECLARE_ROUTINE( PRENOT )
LEX_DECLARE_ROUTINE( GETSEG )
LEX_DECLARE_ROUTINE( GETOFFSET )
LEX_DECLARE_ROUTINE( GETSTINFO )
LEX_DECLARE_ROUTINE( GETTRNAME )


class TApplication{
    public:
    TApplication();
    ~TApplication();
    private:
    char sfmail;
};

// void keyTrap( int key );

TApplication Application;
TZoneView  ZoneView;
TNetView   NetView;
TNodeView  NodeView;
TPointView PointView;
TSearchView SearchView;
TStatusLine StatusLine;
tNodeIdxHdr *header;
tNodeHdrRec *headRec;
tListItem   * NodeList = NULL;
tAddress    * CurPtr = NULL;
tAddress    * result = NULL;
tAddress    CurAddr;
char        *resultFile = NULL;
void        *index;
char saverType = 'R';
int handleIdx;
char iobuff[ sizeof(tNodeIdxRec)*100 ];
long IdxOffset;
char nodepath[65];
void far* DosScr;
unsigned int far* ResAddr;
static unsigned int ResAddrSeg;
static LEX_FLAGS lex_flags;

sellist *selexplist = 0;
sellist *selexplistptr;
selexpr *selexplev;
static char exprnot = 0;

int bkgInfo  = CYAN;
int clrInfo  = BLACK;
int bkgError = RED;
int clrError = WHITE;
int bkgSystem = GREEN;
int clrSystem = BLACK;
int bkgButton = LIGHTGRAY;
int clrButton = RED;

char colorSetup = 0;
char insearch = 0;
char *doesntExist = " doesn't exist, La/\\/\\er!  \r  ";
char *readingIndex = "Reading index...";
char *readingNodelist = "Reading nodelist...";
static char *EscMess = " Esc - Quit ";
char *recompileMess = "  \r  File %s  \r  time mismatch - recompile  \r  ";
char *copyright = "copyright (c) SF-Team 1995-97, (p) Stanislav V. Meckhanoshin (2:5030/143.23)";
char *product = "SF-NODE v4.1";
char *prodwide = "Santa Fox nodelist browser";
char infoActive = 0;

#define compiledMess "compiled at "__DATE__" "__TIME__
char *compiled = compiledMess;
#undef compiledMess

int UTC = 0;

tAddress StartupAddress = {0,0,0,0};

extern int idleTime;

extern "C" {
   extern void cdecl SETBLK();
   extern void cdecl SETINT();
}

static void pass()
{
    tAddress addr = {0,0,0,0};

    if( resultFile )ResAddr = (unsigned int far*)MK_FP( _psp, 0x5C );

    if( !result )result = &addr;
    _fmemcpy( ResAddr, result, sizeof(tAddress) );
    if( resultFile ){
        chmod( resultFile, S_IWRITE );
        unlink( resultFile );
        if( _fmemcmp(ResAddr,&addr,sizeof(tAddress)) ){
            FILE *handle;

            handle = fopen( resultFile, "w" );
            if( !handle ){
                sprintf( iobuff, "  \r  Cannot open result file  \r  %s  \r  ", resultFile );
                resultFile = 0;
                error( iobuff, 19 );
            }
            fprintf( handle, "%u:%u/%u.%u", result->Zone, result->Net, result->Node, result->Point );
            fclose( handle );
        }
    }
}

typedef struct{
    int foreground;
    int background;
}color;

#pragma off (unreferenced)
void ctrlc_ignore(int signum)
{
    mungetch( Esc );
}
#pragma on (unreferenced)

TApplication::TApplication()
{
   unsigned far *p;
   char parent[9];
   int i,j;

   signal(SIGBREAK,ctrlc_ignore);
   signal(SIGINT,ctrlc_ignore);

   _heapgrow();
   DosScr = TScreen::savescr();

   p = (unsigned far*)MK_FP( _psp, 0x16 );    // seg of parent psp (word)
   p = (unsigned far*)MK_FP( (*p) - 1, 8 );   // parent psp mcb owner - 8 bytes
   for( i=j=0; i < 8; i++ )if( p[i] != ' ' )parent[j++] = ((char far*)p)[i];
   parent[j] = 0;
   upper( parent );
   sfmail = !strcmp( parent, "SF-MAIL");
   if( sfmail )ResAddr = (unsigned int far*)MK_FP( 0x40, 0xF0 );
   else ResAddr = (unsigned int far*)MK_FP( _psp, 0x5C );   // own FCB 1
}

TApplication::~TApplication()
{
    close( handleIdx );
    pass();
    TScreen::cursornorm();
    TScreen::restscr( DosScr );
    disableMouse();
    if( !sfmail ){
        fprintf(stderr,"\r%s, %s, %s\n", product, prodwide, compiled );
        fprintf(stderr,"%s\n", copyright );
    }
}


void error( char* str, int err )
{
  wait( str, bkgError, clrError );
  exit( err );
}

/*
void normAddress(tAddress& addr)
{
    if(addr.Zone!=0 && addr.Net==0){
        addr.Net=addr.Zone;
        addr.Zone=0;
    }
    if(addr.Net!=0 && addr.Node==0){
        addr.Node=addr.Net;
        addr.Net=0;
    }
}
*/

int main( int ac, char *av[] )
{
     int i;
     FILE *handle;

     sliceCritical = 1;

     _heapgrow();
     Screen.background = bkgButton;
     Screen.foreground = clrButton;
     if( !Screen.isColor ){
        bkgInfo = LIGHTGRAY;
        clrInfo = BLACK;
        Screen.foreground = BLACK;
        clrError = BLACK;
        bkgError = LIGHTGRAY;
        clrSystem = BLACK;
        bkgSystem = LIGHTGRAY;
     }
     for( i = strlen(av[0]); av[0][i] != '.'; i-- )continue;
     av[0][++i] = 'C';
     av[0][++i] = 'L';
     av[0][++i] = 'R';
     i = sopen( av[0], O_RDONLY|O_BINARY, SH_DENYWR );
     if( i >= 0 ){
        color clr[14];

        if( filelength(i) != 57 ){
            close(i);
            goto LEAVE;
        }
        read( i, (void*)clr, 1u );
        if( *((unsigned char*)clr) )SETBLK();
        else SETINT();
        read( i, &clr[0], sizeof( color )*14 );
        close( i );
        bkgInfo = clr[10].background;
        clrInfo = clr[10].foreground;
        Screen.foreground = clr[4].foreground;
        Screen.background = clr[4].background;
        StatusLine.foreground = clr[5].foreground;
        StatusLine.background = clr[5].background;
        clrError = clr[11].foreground;
        bkgError = clr[11].background;
        bkgButton = clr[12].background;
        clrButton = clr[12].foreground;
        colorSetup = 1;
        ZoneView.backgroundText = NetView.backgroundText = NodeView.backgroundText = PointView.backgroundText = SearchView.backgroundText = clr[0].background;
        ZoneView.colorText = NetView.colorText = NodeView.colorText = PointView.colorText = SearchView.colorText = clr[0].foreground;
        ZoneView.backgroundCurrent = NetView.backgroundCurrent = NodeView.backgroundCurrent = PointView.backgroundCurrent = SearchView.backgroundCurrent = clr[1].background;
        ZoneView.colorCurrent = NetView.colorCurrent = NodeView.colorCurrent = PointView.colorCurrent = SearchView.colorCurrent = clr[1].foreground;

        ZoneView.backgroundCurrentSelected = NetView.backgroundCurrentSelected = NodeView.backgroundCurrentSelected = PointView.backgroundCurrentSelected = SearchView.backgroundCurrentSelected = clr[3].background;
        ZoneView.colorCurrentSelected = NetView.colorCurrentSelected = NodeView.colorCurrentSelected = PointView.colorCurrentSelected = SearchView.colorCurrentSelected = clr[3].foreground;
        ZoneView.backgroundSelected = NetView.backgroundSelected = NodeView.backgroundSelected = PointView.backgroundSelected = SearchView.backgroundSelected = clr[2].background;
        ZoneView.colorSelected = NetView.colorSelected = NodeView.colorSelected = PointView.colorSelected = SearchView.colorSelected = clr[2].foreground;

        ZoneView.backgroundBar = NetView.backgroundBar = NodeView.backgroundBar = PointView.backgroundBar = SearchView.backgroundBar = clr[6].background;
        ZoneView.colorBar = NetView.colorBar = NodeView.colorBar = PointView.colorBar = SearchView.colorBar = clr[6].foreground;
        ZoneView.backgroundBarIndicator = NetView.backgroundBarIndicator = NodeView.backgroundBarIndicator = PointView.backgroundBarIndicator = SearchView.backgroundBarIndicator = clr[7].background;
        ZoneView.colorBarIndicator = NetView.colorBarIndicator = NodeView.colorBarIndicator = PointView.colorBarIndicator = SearchView.colorBarIndicator = clr[7].foreground;
        ZoneView.backgroundWindow = NetView.backgroundWindow = NodeView.backgroundWindow = PointView.backgroundWindow = SearchView.backgroundWindow = clr[8].background;
        ZoneView.colorWindow = NetView.colorWindow = NodeView.colorWindow = PointView.colorWindow = SearchView.colorWindow = clr[8].foreground;
        ZoneView.backgroundGet = NetView.backgroundGet = NodeView.backgroundGet = PointView.backgroundGet = SearchView.backgroundGet = clr[9].background;
        ZoneView.colorGet = NetView.colorGet = NodeView.colorGet = PointView.colorGet = SearchView.colorGet = clr[9].foreground;
        bkgSystem = clr[13].background;
        clrSystem = clr[13].foreground;
    }
LEAVE:
    Screen.cursoroff();
    initMouse();
    Screen.setxy( 1, 1 );
    Screen.outf( "    %s, %-*s", product, Screen.maxCol-19, copyright );
    SetMouseXY( 3, 1 );                             
    StatusLine.say( "%*s", Screen.maxCol, EscMess );
//    StatusLine.say( "%*s", Screen.maxCol, "  Esc - Quit " );
    StatusLine.resize( Screen.maxCol-13-2 );
    if( colorSetup ){
       Screen.setxy( 3, 1 );
       Screen.foreground = clrButton;
       Screen.background = bkgButton;
       Screen.outc( '' );
       Screen.setxy( Screen.maxCol-12, Screen.maxRow );
       Screen.outs( EscMess );
//       Screen.outs( "  Esc - Quit " );
    }
    ZoneView.clrWindow();
    StatusLine.say( "Reading configuration file..." );
    for( i = strlen(av[0]); av[0][i] != '.'; i-- )continue;
    av[0][++i] = 'C';
    av[0][++i] = 'F';
    av[0][++i] = 'G';
    handle = fopen( av[0], "r" );
    if( !handle ){
        sprintf( iobuff, "  \r  Cannot open file  \r  %s  \r  ", av[0] );
        error( iobuff, 4 );
    }
    nodepath[0]=0;
    i = 0;
    lex_flags.FlagCluster = 0;
    do{
        char *p;

        char errstr[80];
        fgets( iobuff, 128, handle );
        p = strchr( iobuff, '\n' );
        if( p )*p = 0;
        i++;
        if( lexical( &CONFIG, &lex_flags, iobuff ) ){
            sprintf( errstr, "  \r  Error in configuration file in line %d:  \r  %s  \r  ", i, lexError() );
        error( errstr, 5 );
        }
    }while( !feof(handle) );
    fclose( handle );
    StatusLine.say( readingIndex );
//    onkey = keyTrap;
    sprintf( iobuff, "%sADNDL.IDX", nodepath );
    handleIdx = sopen( iobuff, O_RDONLY|O_BINARY, SH_DENYWR );
    if( handleIdx < 0 ){
        sprintf( iobuff+64, "  \r  Cannot open index  \r  %s  \r  ", iobuff );
        error( iobuff+64, 1 );
    }
    read( handleIdx, iobuff, sizeof(tNodeIdxHdr)+MAX_NODE_HDR*sizeof(tNodeHdrRec) );
    header  = (tNodeIdxHdr*)iobuff;
    IdxOffset = sizeof(tNodeIdxHdr)+header->TotalNdls*sizeof(tNodeHdrRec);
    index   = malloc( (size_t)IdxOffset );
    memcpy( index, iobuff, (size_t)IdxOffset );
    header  = (tNodeIdxHdr*)index;
    headRec = (tNodeHdrRec*)((char*)index + sizeof(tNodeIdxHdr));

    for( i = 1; i < ac; i++ ){
        if( *av[i] != '/' || isdigit( av[i][1] ) ){
            if( (*av[i] == '.') && (!av[i][1]) )StartupAddress.Zone = StartupAddress.Net = StartupAddress.Node = StartupAddress.Point = 0;
            else{
                if( lexical( &ADDRESS, NULL, av[i] ) ){
                    sprintf( iobuff, "  \r  Error in command line:  \r  %s  \r  ", lexError() );
                    error( iobuff, 10 );
                }
                if((StartupAddress.Zone && (StartupAddress.Node || StartupAddress.Point) && !StartupAddress.Net) ||
                   ((StartupAddress.Zone || StartupAddress.Net) && StartupAddress.Point && !StartupAddress.Node) ||
                   (StartupAddress.Point && (!StartupAddress.Zone || !StartupAddress.Net || !StartupAddress.Node)) ||
                   (StartupAddress.Node && (!StartupAddress.Zone || !StartupAddress.Net)) ||
                   (StartupAddress.Net && !StartupAddress.Zone)){
                        sprintf(iobuff,"  \r  Error in address  \r  %s  \r  ", chrAddress(&StartupAddress,4));
                        error( iobuff, 10 );
                    }
//                normAddress(StartupAddress);
            }
        }else{
            upper( av[i] );
            if( av[i][1] == 'F' && av[i][2] == ':' )resultFile = &av[i][3];
            else if( lexical( &MEMORY, NULL, av[i] ) ){
                sprintf( iobuff, "  \r  Error in command line:  \r  %s  \r  ", lexError() );
                error( iobuff, 10 );
            }
        }
    }

    ZoneView.clrWindow();
    SetMouseXY( 3, 1 );
    ZoneView.activate();

    return 0;
}

LEX_ROUTINE GET_NDL( LEX_TRANSFER * state )
{
    strcpy( nodepath, state->string );
    nodepath[ state->length ] = '\\';
    nodepath[ state->length+1 ] = 0;
    return LEX_SUCCESS;
}

LEX_ROUTINE GET_TIMEOUT( LEX_TRANSFER * state )
{
    idleMax = (int)state->integer;
    return LEX_SUCCESS;
}

LEX_ROUTINE STYPE( LEX_TRANSFER * state )
{
    saverType = state->string[0];
    return LEX_SUCCESS;
}

LEX_ROUTINE GETUTC( LEX_TRANSFER * state )
{
    UTC = (int)state->integer;
    return LEX_SUCCESS;
}

LEX_ROUTINE GETSZONE( LEX_TRANSFER * state )
{
    StartupAddress.Zone = (unsigned int)state->integer;
    StartupAddress.Net   = 0;
    StartupAddress.Node  = 0;
    StartupAddress.Point = 0;
    return LEX_SUCCESS;
}

LEX_ROUTINE GETSNET( LEX_TRANSFER * state )
{
    StartupAddress.Net = (unsigned int)state->integer;
    StartupAddress.Node  = 0;
    StartupAddress.Point = 0;
    if(!StartupAddress.Zone)return 1;
    return LEX_SUCCESS;
}

LEX_ROUTINE GETSNODE( LEX_TRANSFER * state )
{
    StartupAddress.Node = (unsigned int)state->integer;
    StartupAddress.Point = 0;
    if(!StartupAddress.Zone||!StartupAddress.Net)return 1;
    return LEX_SUCCESS;
}

LEX_ROUTINE GETSPOINT( LEX_TRANSFER * state )
{
    StartupAddress.Point = (unsigned int)state->integer;
    if(!StartupAddress.Zone||!StartupAddress.Net||!StartupAddress.Node)return 1;
    return LEX_SUCCESS;
}

LEX_ROUTINE GETSEL( LEX_TRANSFER * state )
{
    if( selexplist && selexplev->and ){
        selexplev = selexplev->and;
    }else{
        if( selexplist ){
            selexplistptr->next = (sellist*)malloc( sizeof( sellist ) );
            selexplistptr = selexplistptr->next;
        }else selexplist = selexplistptr = (sellist*)malloc( sizeof( sellist ) );
        selexplistptr->next = 0;
        selexplev = selexplistptr->expr = (selexpr*)malloc( sizeof( selexpr ) );
    }
    selexplev->string = (char*)malloc( state->length+1 );
    strcpy( selexplev->string, state->string );
    selexplev->and = 0;
    selexplev->not = exprnot;
    exprnot = 0;
    return LEX_SUCCESS;
}

#pragma off (unreferenced)
LEX_ROUTINE PREAND( LEX_TRANSFER * state )
{
    selexplev->and = (selexpr*)malloc( sizeof( selexpr ) );
    return LEX_SUCCESS;
}
#pragma on (unreferenced)

#pragma off (unreferenced)
LEX_ROUTINE PRENOT( LEX_TRANSFER * state )
{
    exprnot = 1;
    return LEX_SUCCESS;
}
#pragma on (unreferenced)

LEX_ROUTINE GETSEG( LEX_TRANSFER * state )
{
    ResAddrSeg = (unsigned int)state->integer;
    return LEX_SUCCESS;
}

LEX_ROUTINE GETOFFSET( LEX_TRANSFER * state )
{
    ResAddr = (unsigned int far*)MK_FP( ResAddrSeg, (unsigned int)state->integer );
    return LEX_SUCCESS;
}

extern void toggleInfo(void);
#pragma off (unreferenced)
LEX_ROUTINE GETSTINFO( LEX_TRANSFER * state )
{
    if( infoActive )return LEX_SUCCESS;
    toggleInfo();
    return LEX_SUCCESS;
}
#pragma on (unreferenced)

#pragma off (unreferenced)
LEX_ROUTINE GETTRNAME( LEX_TRANSFER * state )
{
    lex_flags.Flags.noTruename = 1;
    return LEX_SUCCESS;
}
#pragma on (unreferenced)

