#ifndef _SF_NODE_H_
#define _SF_NODE_H_

#include "view.h"
#include "ndl.h"
#include "tstatus.h"
#include "colors.h"

#define  O_DENYWRITE   0x20

typedef struct{
    char Royal[10];
    char BBS_Name[44];
    char Place[44];
    char SysOp[44];
}NdlLine;

typedef struct{
    tNodeIdxRec NodeIdxRec;
    char *collection;
}tListItem;

extern char iobuff[ sizeof(tNodeIdxRec)*100 ];
extern TZoneView  ZoneView;
extern TNetView   NetView;
extern TNodeView  NodeView;
extern TPointView PointView;
extern TSearchView SearchView;
extern TStatusLine StatusLine;
extern tNodeIdxHdr *header;
extern tNodeHdrRec *headRec;
extern tListItem   *NodeList;
extern tAddress    *CurPtr;
extern tAddress    *result;
extern tAddress    CurAddr;
extern void        *index;
extern int handleIdx;
extern long IdxOffset;
extern char nodepath[65];
extern char insearch;
extern tAddress StartupAddress;

extern int bkgInfo, clrInfo, bkgError, clrError, clrSystem, bkgSystem;
extern int bkgButton;
extern int clrButton;
extern char *doesntExist;
extern char *readingIndex;
extern char *readingNodelist;
extern char *recompileMess;
extern char *copyright;
extern char *product;
extern char *prodwide;
extern char *compiled;
extern char infoActive;


char *chrAddress( tAddress * Address, int level );
long searchNode( tAddress *, long offset );
void * allocList( size_t Size );
int parseNdl( const char *str, NdlLine& ndl );
char* expandStr( char* ptr, const char * c );
void error( char* str, int err );
void pass();
char* getSysop( char *io, char * c );
char * gettoken( char *dest, const char * src );
void WaitWindow( unsigned char* mess,
                 unsigned char* delm,
                 unsigned int bcolor,
                 unsigned int tcolor,
                 unsigned int dcolor,
                 unsigned int top = 0u,
                 unsigned int left = 0u,
                 unsigned int* topx = 0,
                 unsigned int* topy = 0,
                 unsigned int shadow = 1,
                 unsigned int frame = 1,
                 int maxlen = 0
           );
void wait( char *mess, int bkg, int clr );

#endif
