#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <share.h>
#include "mouse.h"
#include "key.h"
#include "tscreen.h"
#include "colors.h"

extern "C" {
   extern void cdecl SETBLK();
   extern void cdecl SETINT();
}

// #define SETBLK() disp_setattr(DISP_NORMAL|DISP_BLINK)
// #define SETINT() disp_setattr(DISP_NORMAL|DISP_INTENSITY)

char *bar[] = { "View main color",
                "Current pointer",
                "Selected color",
                "Selected pointer",
                "Screen top line",
                "Status Line",
                "Scroll bar",
                "Scroll bar pointer",
                "Dialog windows",
                "Get fields",
                "Information windows",
                "Error messages",
                "Buttons",
                "Node information"
               };

char blink = 1;

#define itemCnt 14
#define DEMO_X  27
#define DEMO_Y  4


typedef struct{
    int foreground;
    int background;
}color;

color clr[ itemCnt ] = { {LIGHTGRAY,BLUE},
                         {BLACK,CYAN},
                         {YELLOW,BLUE},
                         {YELLOW,CYAN},
                         {RED,LIGHTGRAY},
                         {RED,LIGHTGRAY},
                         {BLACK,BROWN},
                         {WHITE,BROWN},
                         {BLACK,LIGHTGRAY},
                         {BLACK,CYAN},
                         {BLACK,CYAN},
                         {WHITE,RED},
                         {RED,LIGHTGRAY},
                         {BLACK,GREEN}
                       };
int curline = 0;

void selectLine( int left, int top, int right, int background, int text )
{
  int i,j;

  top--;
  left--;
  i=top*Screen.maxCol*2+left*2+1;
  disableMouse();
  for( j=0; j< ((right-left)<<1); j+=2 ){
    Screen.screenAddr[ i+j ] = (unsigned char)((text&0x0F) + ((background&0x0F)<<4));
  }
  enableMouse();
}

void screenSaver(){}
extern "C" {
int NC_Color(){ return -1; }
}

void drawColorScheme()
{
    int x, y;
    TScreen scr;

    for( y=0; y<16; y++ ){
        scr.background = LIGHTGRAY;
        scr.foreground = BLACK;
        if( y == 0 || y == 15 ){
            scr.setxy( 59, y?5+16:4 );
            scr.outs( "" );
        }
        scr.setxy( 59, y+5 );
        scr.outc( '' );
        scr.setxy( 60+16, y+5 );
        scr.outc( '' );
        for( x=0; x<16; x++ ){
            scr.setxy( x+60, y+5 );
            scr.foreground = x;
            scr.background = y;
            scr.outc( '' );
        }
    }
}

void setColorSchemePos( color& c )
{
    Screen.screen_setxy( c.foreground+60, c.background+5 );
}


void getcolor( color& c )
{
    int i;

    setColorSchemePos( c );
    switch( i = mgetch() ){
        case Up:        if( --c.background < 0 )c.background = 15;
                                break;
        case Left:      if( --c.foreground < 0 )c.foreground = 15;
                                break;
        case Down:      if( ++c.background > 15 )c.background = 0;
                                break;
        case Right:     if( ++c.foreground > 15 )c.foreground = 0;
                                break;
        case LMB:       if( mouseX >= 60 && mouseX <= 75 && mouseY >=5
                            && mouseY <= 20 ){
                            c.foreground = mouseX-60;
                            c.background = mouseY-5;
                        }
                        break;
        default:        mungetch( i );
    }
    setColorSchemePos( c );
}


void updateDemo( int start = 0 )
{
    int i;
    TScreen scr;

    for( i=start; i<itemCnt; i++ ){
        scr.foreground = clr[i].foreground;
        scr.background = clr[i].background;
        switch( i ){
            case 0: scr.clrArea( DEMO_X, DEMO_Y+1, DEMO_X+27, DEMO_Y+13 );
                    scr.setxy( DEMO_X, DEMO_Y+1 );
                    scr.outs( "Zone   1       Americano Gre" );
                    scr.setxy( DEMO_X, DEMO_Y+3 );
                    scr.outs( "Zone   3       Abori" );
                    break;
            case 1: scr.setxy( DEMO_X, DEMO_Y+2 );
                    scr.outs( "Zone   2       Old w" );
                    break;
            case 2: scr.setxy( DEMO_X, DEMO_Y+4 );
                    scr.outs( "Zone   4       Whate" );
                    break;
            case 3: scr.setxy( DEMO_X, DEMO_Y+5 );
                    scr.outs( "Zone   5       So " );
                    break;
            case 4: scr.setxy( DEMO_X, DEMO_Y );
                    scr.outs( "   SF-NODE v4.0 copyright (c)" );
                    break;
            case 5: scr.setxy( DEMO_X, DEMO_Y+17 );
                    scr.outs( "Mongyschlackh,28800," );
                    break;
            case 6: scr.clrArea( DEMO_X+28, DEMO_Y+1, DEMO_X+28, DEMO_Y+16, '' );
                    break;
            case 7: scr.clrArea( DEMO_X+28, DEMO_Y+5, DEMO_X+28, DEMO_Y+8, '' );
                    break;
            case 8: scr.clrArea( DEMO_X+6, DEMO_Y+6, DEMO_X+17, DEMO_Y+11 );
                    scr.setxy( DEMO_X+8, DEMO_Y+7 );
                    scr.outs( "" );
                    scr.setxy( DEMO_X+8, DEMO_Y+8 );
                    scr.outs( " Enter se" );
                    scr.setxy( DEMO_X+8, DEMO_Y+9 );
                    scr.outc( '' );
                    scr.setxy( DEMO_X+8, DEMO_Y+10 );
                    scr.outs( "" );
                    break;
            case 9: scr.setxy( DEMO_X+10, DEMO_Y+9 );
                    scr.outs( "Get Fiel");
                    break;
            case 10:scr.clrArea( DEMO_X+20, DEMO_Y+2, DEMO_X+27, DEMO_Y+15 );
                    scr.setxy( DEMO_X+22, DEMO_Y+3 );
                    scr.outs( "" );
                    scr.setxy( DEMO_X+22, DEMO_Y+4 );
                    scr.outs( "  F1" );
                    scr.setxy( DEMO_X+22, DEMO_Y+13 );
                    scr.outs( "  Al");
                    scr.setxy( DEMO_X+22, DEMO_Y+14 );
                    scr.outs( "" );
                    break;
            case 11:scr.clrArea( DEMO_X+18, DEMO_Y+5, DEMO_X+27, DEMO_Y+12 );
                    scr.setxy( DEMO_X+20, DEMO_Y+6 );
                    scr.outs( "" );
                    scr.setxy( DEMO_X+20, DEMO_Y+7 );
                    scr.outc( '' );
                    scr.setxy( DEMO_X+20, DEMO_Y+8 );
                    scr.outs( "  Not e");
                    scr.setxy( DEMO_X+20, DEMO_Y+9 );
                    scr.outs( "    mem" );
                    scr.setxy( DEMO_X+20, DEMO_Y+10 );
                    scr.outc( '' );
                    scr.setxy( DEMO_X+20, DEMO_Y+11 );
                    scr.outs( "" );
                    break;
            case 12:scr.setxy( DEMO_X+20, DEMO_Y+17 );
                    scr.outs( "A Esc -" );
                    scr.setxy( DEMO_X+1, DEMO_Y );
                    scr.outc( '' );
                    break;
            case 13:scr.setxy( DEMO_X, DEMO_Y+14 );
                    scr.outs( "           -1:-1/-1.");
                    scr.setxy( DEMO_X, DEMO_Y+15 );
                    scr.outs( "     Mongyschlackh m");
                    scr.setxy( DEMO_X, DEMO_Y+16 );
                    scr.outs( "           Flags: None      ");
                    break;
        }
    }
}

void save()
{
        int i;
        i = sopen( "SF-NODE.CLR", O_WRONLY | O_BINARY | O_CREAT | O_TRUNC, SH_DENYRW, S_IWRITE );
        write( i, &blink, 1u );
        write( i, clr, sizeof( color )*itemCnt );
        close( i );
        chmod( "SF-NODE.CLR", S_IWRITE );
}

void restore()
{
        int i;
        i = sopen( "SF-NODE.CLR", O_RDONLY|O_BINARY, SH_DENYWR );
        if( i < 1 )return;
        if( filelength(i) != 57 )goto LEAVE;
        read( i, &blink, 1u );
        read( i, &clr[0], sizeof( color )*itemCnt );
LEAVE:
        close( i );
}

void main(void)
{
    int i;

//    TScreen::cursorblock();
    restore();
    initMouse();
    if( blink )SETBLK();
    else SETINT();
    Screen.foreground = LIGHTGRAY;
    Screen.background = BLACK;
    Screen.clrScreen();
    Screen.background = LIGHTGRAY;
    Screen.foreground = BLACK;
    Screen.outf( "%-*s", Screen.maxCol, "SF-NODE Color Setup v4.0, copyright (c) 1995-1996 SF-Team, (p) Stas Mehanoshin" );
    Screen.setxy( 1, Screen.maxRow );
    Screen.outf( "%-*s", Screen.maxCol, "PgUp  PgDn  \x1A  \x1B      Space - Blinking  Esc - Quit  F10 - Exit'n'Save" );
    Screen.setxy( 2, 4 );
    Screen.outs( "" );
    Screen.setxy( 2, 5+itemCnt );
    Screen.outs( "" );
    for( i = 0; i < itemCnt; i++ ){
        Screen.setxy( 2, i+5 );
        Screen.outf( "%-19s", bar[i] );
    }
    drawColorScheme();

    while(1){
        selectLine( 3, curline+5, 2+20, BLACK, LIGHTGRAY );
        setColorSchemePos( clr[ curline ] );
        updateDemo(curline);
        i = mgetch();
        switch( i ){
                case PgDown:    selectLine( 3, curline+5, 2+20, LIGHTGRAY, BLACK );
                                if( ++curline == itemCnt )curline = 0;
                                break;
                case PgUp:      selectLine( 3, curline+5, 2+20, LIGHTGRAY, BLACK );
                                if( --curline < 0 )curline = itemCnt-1;
                                break;
                case Left:
                case Right:
                case Down:
                case Up:        mungetch( i );
SELECT:                         getcolor( clr[ curline ] );
                                break;
                case Esc:       goto END;
                case LMB:       if( mouseX >= 3 && mouseX < 2+19 &&
                                mouseY >= 5 && mouseY < 5+itemCnt ){
                                        selectLine( 3, curline+5, 2+20, LIGHTGRAY, BLACK );
                                        curline = mouseY-5;
                                }
                                if( mouseX >= 60 && mouseX <= 75 && mouseY >=5
                                && mouseY <= 20 ){
                                        clr[ curline ].foreground = mouseX-60;
                                        clr[ curline ].background = mouseY-5;
                                        goto SELECT;
                                }
                                if( mouseY == Screen.maxRow ){
                                        if( mouseX < 6 )mungetch( PgUp );
                                        if( mouseX > 6 && mouseX < 13 )mungetch( PgDown );
                                        if( mouseX > 13 && mouseX < 17 )mungetch( Right );
                                        if( mouseX > 17 && mouseX < 21 )mungetch( Left );
                                        if( mouseX > 21 && mouseX < 25 )mungetch( Up );
                                        if( mouseX > 25 && mouseX < 29 )mungetch( Down );
                                        if( mouseX > 29 && mouseX < 48 )mungetch( Blank );
                                        if( mouseX > 48 && mouseX < 61 )mungetch( Esc );
                                        if( mouseX > 61 && mouseX )mungetch( F10 );
                                        mouseWaitRelease();
                                }
                                break;
                case Blank:     if( blink ){
                                        blink = 0;
                                        SETINT();
                                }else{
                                        blink = 1;
                                        SETBLK();
                                }
                                break;
                case F10:       save();
                                goto END;
        }
    }
END:
    Screen.foreground = LIGHTGRAY;
    Screen.background = BLACK;
    Screen.clrScreen();
    disableMouse();
}
