#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <process.h>
#include <stdlib.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include <share.h>
#include <bios.h>
#include "sf-node.h"
#include "country.h"
#include "view.h"
#include "ndl.h"
#include "key.h"
#include "tscreen.h"
#include "tstatus.h"
#include "mouse.h"
#include "selexpr.h"
#include "slice.h"

extern char *resultFile;
extern unsigned int far* ResAddr;
void about( void );
void help( void );
void screenSaver();

char ndlBuff[152];
static char *ndlOpenFail = "  \r  Cannot open nodelist  \r  %s  \r  ";

TLevelView *thisClass;


int lines;

extern "C"{
    int cmpBBS( const void* p1, const void* p2 );
    int cmpSysop( const void* p1, const void* p2 );
    int cmpAddress( const void* p1, const void* p2 );
    int cmpHub( const void* p1, const void* p2 );
}

void toggleInfo(void)
{
    int i;

    infoActive = !infoActive;
    i = ZoneView.wBottom;
    i = infoActive?i-7:i+7;
    ZoneView.resize( ZoneView.wTop, ZoneView.wLeft, i, ZoneView.wRight );
    NetView.resize( ZoneView.wTop, ZoneView.wLeft, i, ZoneView.wRight );
    NodeView.resize( ZoneView.wTop, ZoneView.wLeft, i, ZoneView.wRight );
    PointView.resize( ZoneView.wTop, ZoneView.wLeft, i, ZoneView.wRight );
    SearchView.resize( ZoneView.wTop, ZoneView.wLeft, i, ZoneView.wRight );
}

void normalize( char *buff, int l )
{
    char *p;

    buff[l] = 0;
    p = strchr( buff, 0x0D );
    if( p ){
        p[0]='\n';
        p[1]=0;
    }
}

int checkSelection( char* buff )
{
    for( selexplistptr = selexplist; selexplistptr; selexplistptr = selexplistptr->next ){
        for( selexplev = selexplistptr->expr; selexplev; selexplev = selexplev->and ){
            if( strstr( buff, selexplev->string ) ){
                if( selexplev->not )goto NEXT_SELECT;
            }else{
                if( !selexplev->not )goto NEXT_SELECT;
            }
        }
        return 1;
NEXT_SELECT:;
    }
    return 0;
}


TLevelView::TLevelView()
{
    if( isColor ){
        backgroundCurrent = CYAN;
        backgroundCurrentSelected = CYAN;
        colorCurrentSelected = YELLOW;
        colorSelected = YELLOW;
        backgroundSelected = BLUE;
    }
    order = 0;
    stableOn = 0;
    QuickSearchFlag = 1;
}

void TLevelView::next()
{
    if( current < ((tListItem*)head)+lineCnt-1){
        current = ((char*)current)+sizeof(tListItem);
    }
}

void TLevelView::prev()
{
    if( current > head ){
        current = ((char*)current)-sizeof(tListItem);
    }
}

char* TLevelView::getLine()
{
    char *ptr;
    tAddress * addr;

    ptr = chrAddress( (tAddress*)current, level );
    ptr = expandStr( ptr, ((tListItem*)current)->collection );

    if( ((tNodeIdxRec*)current)->NdlNo & 0x80 ){
        ptr[ 21 ] = '[';
        ptr[ 22 ] = '+';
        ptr[ 23 ] = ']';
    }

    addr = (tAddress*)current;
    if( !isUnknown() )return ptr;
    strncpy( ptr, "Unknown ", 8 );
    ptr[26] = 0;
    return ptr;
}

void TLevelView::parseNodeLine( const char *buff, int i )
{
    NdlLine ndl;
    int l1, l2, l3;

    parseNdl( buff, ndl );
    l1 = strlen(ndl.Royal);
    l2 = strlen(ndl.BBS_Name);
    l3 = strlen(ndl.SysOp);
    NodeList[i].collection = (char*)malloc( l1+l2+l3+3 );
    if( !NodeList[i].collection || _memmax() < 4500 ){
        error( "  \r  Not enough memory  \r  ", 3 );
    }
    strcpy( NodeList[i].collection, ndl.Royal );
    NodeList[i].collection[l1] = ',';
    strcpy( NodeList[i].collection+l1+1, ndl.BBS_Name );
    NodeList[i].collection[l1+l2+1] = ',';
    strcpy( NodeList[i].collection+l1+l2+2, ndl.SysOp );
}


int TLevelView::collectStr(int isNow)
{
    int i, n, last = 0xFFFF;
    int handle = -1;
    char *name;
    char fnm[65];
    int len;
    unsigned long ftime;

    long now;
    extern int UTC;

    StatusLine.say( readingNodelist );

    if( isNow ){
        _bios_timeofday(0,&now);
        now = now/182/6;
    }

    stableOn = 0;

    strcpy( fnm, nodepath );
    name = fnm+strlen( fnm );
    len = sizeof(tListItem)*lineCnt;
    for( i=0; i<lineCnt; i++ ){
        if( mkbhit() == Esc ){
            mgetch();
            exit(0);
        }
        n = ( NodeList[i].NodeIdxRec.NdlNo & 0x3F ) - 1;
        strncpy( name, headRec[ n ].Name, (int)(headRec[ n ].NameLen) );
        name[ (int)(headRec[ n ].NameLen) ] = 0;
        if( n != last ){
            close( handle );
            handle = sopen( fnm, O_RDONLY|O_BINARY, SH_DENYWR );
            last = n;
            if( handle < 0 ){
                sprintf( iobuff, ndlOpenFail, fnm );
                error( iobuff, 2 );
            }
            _dos_getftime( handle, ((unsigned short*)&ftime)+1, (unsigned short*)&ftime );
            if( ftime != headRec[n].Time ){
                sprintf( iobuff, recompileMess, fnm );
                error( iobuff, 4 );
            }
        }
        lseek( handle, NodeList[i].NodeIdxRec.NdlOfs, SEEK_SET );
        read( handle, (void*)iobuff, 150 );
        normalize( iobuff, 149 );
        if( isNow ){
            long workTime_Low, workTime_High;
            int j;
            char* p;

            workTime_Low = workTime_High = 0;
            for( j=0,p=iobuff; (j<5)&&p; j++ )p=strchr(p,',')+1;
            if( p )if(strstr( p-1, ",CM" ))workTime_High = now;
            else{
                if( p )p = strstr( p-1, ",T" );
                if( p ){
                  p += 2;
                  workTime_Low = *p-((*p > 'Z')?'a':'A');
                  workTime_Low  += UTC;
                  if( workTime_Low > 23 )workTime_Low -= 24;
                  workTime_Low *= 60;
                  workTime_Low += *p > 'Z'?30:0;
                  p++;
                  workTime_High = *p-((*p > 'Z')?'a':'A');
                  workTime_High += UTC;
                  if( workTime_High > 23 )workTime_High -= 24;
                  workTime_High *= 60;
                  workTime_High += *p > 'Z'?30:0;
                }
            }
            if( ((workTime_Low<workTime_High) && (now >= workTime_Low ) && (now <= workTime_High)) ||
                ((workTime_Low>workTime_High) && ((now <= workTime_High) || (now >= workTime_Low ))) )NodeList[i].NodeIdxRec.NdlNo |= 0x40;
            else NodeList[i].NodeIdxRec.NdlNo &= ~0x40;
        }else{
            if( checkSelection( iobuff ) )NodeList[i].NodeIdxRec.NdlNo |= 0x40;
            parseNodeLine( iobuff, i );
        }
    }
    close( handle );
    StatusLine.clear();
    return 1;
}

void TLevelView::releaseStr()
{
    int i;

    for( i=0; i<lineCnt; i++ )if(NodeList[i].collection){
        free( NodeList[i].collection );
        NodeList[i].collection = 0;
    }
}

char* getBBS( char *io, char * c )
{
    char * p;
    int n;

    p = strchr( c, ',' );
    if( p ){
        p++;
        c = strchr( p, ',' );
        if( c ){
            n = (int)(c-p)-1;
//        n = (int)(strchr( p, ',' )-p)-1;
            strncpy( io, p, n );
            io[n] = 0;
            upper( io );
        }else io[0]=0;
    }else io[0] = 0;
    return io;
}

char* getSysop( char *io, char* c )
{
    char * p;

    p = strchr( c, ',' );
    if( p ){
        p++;
        p = strchr( p, ',' );
        if( p ){
            p++;
            strcpy( io, p );
            upper( io );
        }else io[0]=0;
    }else io[0]=0;
    return io;
}


int cmpBBS( const void * p1, const void * p2 )
{
    int r1, r2;

    r1 = thisClass->isUnknown(p1);
    r2 = thisClass->isUnknown(p2);
    if( r1 && r2 )return cmpAddress( p1, p2 );
    if( r1 || r2 )return r1-r2;
    return strcmp( getBBS( iobuff   , ((tListItem*)p1)->collection ),
                   getBBS( iobuff+64, ((tListItem*)p2)->collection ) );
}

int cmpSysop( const void* p1, const void* p2 )
{
    int r1, r2;

    r1 = thisClass->isUnknown(p1);
    r2 = thisClass->isUnknown(p2);
    if( r1 && r2 )return cmpAddress( p1, p2 );
    if( r1 || r2 )return r1-r2;
    return strcmp( getSysop( iobuff   , ((tListItem*)p1)->collection ),
                   getSysop( iobuff+64, ((tListItem*)p2)->collection ) );
}

int cmpAddress( const void* p1, const void* p2 )
{
    if( ((tListItem*)p1)->NodeIdxRec.Address ==
        ((tListItem*)p2)->NodeIdxRec.Address )return 0;
    if( ((tListItem*)p1)->NodeIdxRec.Address <
        ((tListItem*)p2)->NodeIdxRec.Address )return -1;
    return 1;
}

int cmpHub( const void* p1, const void* p2 )
{
    static short Route1,Route2;
    if( p1 == p2 )return 0;
    Route1 = ((tListItem*)p1)->NodeIdxRec.Address.Node?((tListItem*)p1)->NodeIdxRec.RouteNode:0;
    Route2 = ((tListItem*)p2)->NodeIdxRec.Address.Node?((tListItem*)p2)->NodeIdxRec.RouteNode:0;
    if( Route1 == Route2 ){
            if( Route1 ==
                ((tListItem*)p1)->NodeIdxRec.Address.Node )return -1;
            if( Route2 ==
                ((tListItem*)p2)->NodeIdxRec.Address.Node )return  1;
            return cmpAddress( p1, p2 );
        }
    if( Route1 < Route2 )return -1;
    return 1;
}

int cmpRegion( const void* p1, const void* p2 )
{
    if( p1 == p2 )return 0;
    if( ((tListItem*)p1)->NodeIdxRec.RouteNode ==
        ((tListItem*)p2)->NodeIdxRec.RouteNode ){
            if( ((tListItem*)p1)->NodeIdxRec.RouteNode ==
                ((tListItem*)p1)->NodeIdxRec.Address.Net )return -1;
            if( ((tListItem*)p2)->NodeIdxRec.RouteNode ==
                ((tListItem*)p2)->NodeIdxRec.Address.Net )return  1;
            return cmpAddress( p1, p2 );
        }
    if( ((tListItem*)p1)->NodeIdxRec.RouteNode <
        ((tListItem*)p2)->NodeIdxRec.RouteNode )return -1;
    return 1;
}


void TLevelView::sort( char ord )
{
    tAddress old;

    sliceCritical = 1;

    old = *(tAddress*)current;
    clrWindow();
    if( ord )order = (char)(ord-1);
    lines = lineCnt;
    thisClass = this;

    switch( order ){
        case 0:
            StatusLine.say( "Sorting by BBS Name..." );
            qsort( (void*)NodeList, lineCnt, sizeof(tListItem), cmpBBS );
            break;
        case 1:
            StatusLine.say( "Sorting by Sysop Name..." );
            qsort( (void*)NodeList, lineCnt, sizeof(tListItem), cmpSysop );
            break;
        case 2:
            if( level == 3 ){
                StatusLine.say( "Sorting by Hub..." );
                qsort( (void*)NodeList, lineCnt, sizeof(tListItem), cmpHub );
                break;
            }else if( level == 2 ){
                StatusLine.say( "Sorting by Region..." );
                qsort( (void*)NodeList, lineCnt, sizeof(tListItem), cmpRegion );
                break;
            }else order++;
        case 3:
            StatusLine.say( "Sorting by Address..." );
            qsort( (void*)NodeList, lineCnt, sizeof(tListItem), cmpAddress );
            break;
    }
    order++;
    stableOn = 0;
    if( order > 3 )order = 0;
    if( !ord ){
        curPos = 0;
        head = current = NodeList;
        while( ! (old == *(tAddress*)current) ){
            next();
            curPos++;
        }
    }
    StatusLine.clear();
    show( curPos );
    sliceCritical = 0;
}

void TLevelView::forceUpdate( void )
{
    char *name;
    char fnm[70];
    int n;
    int handle = -1;
    char * last;
    unsigned long ftime;

    if( current == stableOn )return;
    if( mkbhit() )return;

    if( isUnknown() ){
        StatusLine.say( "Unknown address" );
        goto Rest;
    }

    strcpy( fnm, nodepath );
    name = fnm+strlen( fnm );
    n = (((tNodeIdxRec*)current)->NdlNo & 0x3F ) - 1;
    strncpy( name, headRec[ n ].Name, (int)(headRec[ n ].NameLen) );
    name[ (int)(headRec[ n ].NameLen) ] = 0;
    handle = sopen( fnm, O_RDONLY|O_BINARY, SH_DENYWR );
    if( handle < 0 ){
        sprintf( iobuff, ndlOpenFail, fnm );
        error( iobuff, 2 );
    }
    _dos_getftime( handle, ((unsigned short*)&ftime)+1, (unsigned short*)&ftime );
    if( ftime != headRec[n].Time ){
        sprintf( iobuff, recompileMess, fnm );
        error( iobuff, 4 );
    }
    lseek( handle, ((tNodeIdxRec*)current)->NdlOfs, SEEK_SET );
    read( handle, (void*)ndlBuff, 150 );
    close( handle );
    normalize( ndlBuff, 149 );
    if( mkbhit() )return;
    last = strchr( ndlBuff, '\n' );
    if( last )*last = 0;
    while( last = strchr( ndlBuff, '_' ) )*last=' ';
    last = gettoken( fnm, ndlBuff );
    last = gettoken( fnm, last );
    last = gettoken( fnm, last );
    last = gettoken( fnm, last );
    n = strlen(fnm);
    if( mkbhit() )return;
    last = strchr( last, ',' );
    strncpy( fnm+n, last, 69-n );
    fnm[ (maxCol-13 < 69)?maxCol-13:69 ] = 0;
    StatusLine.say( fnm );
Rest:
    stableOn = current;

    Screen.foreground = clrButton;
    Screen.background = bkgButton;
    Screen.setxy( StatusLine.length+1, maxRow );
    Screen.outc( '');
    Screen.outc( (order)?((order==1)?'B':(order==2)?'S':((level==2)?'R':'H')):'A' );

    if( infoActive )info();

}

void TLevelView::info(void)
{
    tAddress addr;
    NdlLine ndl;
    char buff[1024];
    char * last;
    char * p;

    char buff1[4];
    char buff2[4];
    char buff3[4];
    char buff4[4];

    extern int UTC;

    if( mkbhit() )return;
    parseNdl( ndlBuff, ndl );
    addr = *(tAddress*)current;
    if( isUnknown() ){
        WaitWindow( (unsigned char*)" \r \r This address unknown -\rcheck nodelist\r \r \r ", NULL, bkgError, clrError, clrError, wBottom-1, 0u, 0, 0, 0, 0, wWidth );
        return;
    }
    addr.Node = ((tNodeIdxRec*)current)->RouteNode;
    last = gettoken( iobuff, ndlBuff );
    last = gettoken( iobuff, last );
    last = gettoken( iobuff, last );
    last = gettoken( iobuff, last );
    if( (level == 3 || level==4 && !((tAddress*)current)->Point) && ((tAddress*)current)->Node )
        strcpy( iobuff+44, (addr.Node && ((tAddress*)current)->Node != addr.Node )?chrAddress( &addr, 3 ):"-Unknown-" );
    else if(level == 2 || (level == 3 && !((tAddress*)current)->Node) ){
        addr.Net = ((tNodeIdxRec*)current)->RouteNode;
        strcpy( iobuff+44, addr.Net?chrAddress( &addr, 2 ):"-Unknown-" );
    }else iobuff[44] = NULL;
    last = gettoken( iobuff+74, last );
    last = gettoken( iobuff+74, last );
    last = gettoken( iobuff+112, last );
    if( strlen( last ) > wWidth-18 ){
        p = strchr( last+wWidth-38, ',' );
        if( p++ ){
            strcpy( ndlBuff, p );
            strcpy( p, "  \r  " );
            strcpy( p+5, ndlBuff );
        }
    }

    sprintf( buff,
 "%s %s (%02s%03s%03s.%02s) %s\
\r%s from %s\
\r%s %s\
\rPhone %s\
\rSpeed %s\
\rFlags %s\
\r"
        , ndl.Royal
        , chrAddress( (tAddress*)current, (level>=4)?level:3 )
        , itoa(((tAddress*)current)->Zone,buff1,32), itoa(((tAddress*)current)->Net,buff2,32), itoa(((tAddress*)current)->Node,buff3,32), itoa(((tAddress*)current)->Point,buff4,32)
        , ndl.BBS_Name
        , ndl.SysOp
        , iobuff
        , ((level==3 || level==4 && !((tAddress*)current)->Point) && ((tAddress*)current)->Node)?"Route via":(level==2 || (level==3 && !((tAddress*)current)->Node))?"Region":"",iobuff+44
        , iobuff+74
        , iobuff+112
        , (char*)last );                   // ! near!!!!

    p = strstr( last-1, ",T" );
    if( p ){
      int bh, eh, bm, em;
      p += 2;
      bh = *p-((*p > 'Z')?'a':'A');
      bm = *p > 'Z'?30:0;
      p++;
      eh = *p-((*p > 'Z')?'a':'A');
      em = *p > 'Z'?30:0;
      bh += UTC;
      eh += UTC;
      if( bh > 23 )bh -= 24;
      if( eh > 23 )eh -= 24;
      sprintf( ndlBuff, "(%02d:%02d-%02d:%02d)", bh, bm, eh, em );
      strcat( buff, ndlBuff );
    }else strcat( buff, " " );
    WaitWindow( (unsigned char*)buff, NULL, bkgSystem, clrSystem, clrSystem, wBottom-1, 0u, 0, 0, 0, 0, wWidth );
}

int TLevelView::isSelected( void )
{
    return ((tNodeIdxRec*)current)->NdlNo & 0x40;
}

void TLevelView::wait( char *mess )
{
    StatusLine.say( mess );
    stableOn = 0;
}

int TLevelView::isUnknown( const void* ptr )
{
    switch( level ){
        case 1:
            if( ((tAddress*)ptr)->Net != ((tAddress*)ptr)->Zone )return 1;
        case 2:
            if( ((tAddress*)ptr)->Node )return 1;
        case 3:
            if( ((tAddress*)ptr)->Point )return 1;
    }
    return 0;
}

void TLevelView::handleEvent()
{
    switch( key ){
        case Esc:   exit(0);
        case Enter: if( isUnknown() ){
                        if( infoActive )break;
                        else goto Info;
                    }
                    result = (tAddress*)current;
                    exit(0);
        case AltS:  sort();
                    break;
        case MMB:
        case Tab:
        case AltI:
        Info:       toggleInfo();
                    update();
                    stableOn = 0;
                    forceUpdate();
                    break;
        case RMB:
        case LMB:
                    if((mouseStatus()&3)==3){
                        mouseWaitRelease();
                        goto Info;
                    }else if(key==RMB)break;
                    if( lastDirection ){
                        TView::handleEvent();
                        return;
                    }
                    if( mouseX == StatusLine.length+2 && mouseY == maxRow ){
                        sort();
                        mouseWaitRelease();
                        break;
                    }
                    mouseStatus();
                    if( mouseX > maxCol-12 && mouseY == maxRow )exit(0);
                    if( mouseX > 1 && mouseX < 5 && mouseY == 1 )about();
                    else{
                        TView::handleEvent();
                        return;
                    }
                    break;
        case F1:
        case AltH:
                    help();
                    break;
        case AltA:
        case F9:
                    about();
                    break;
        case ShiftF7:
                    break;
        case AltM:
        case Ins:
                    if( !SearchView.lineCnt ){
                        SearchView.AKAmatching = 1;
                        mungetch( 0xF01 );
                    }
                    break;
        case AltF:
        case F7:
                    if( !SearchView.lineCnt ){
                        if( SearchView.findDlg() )mungetch( 0xF01 );
                    }
                    break;
        case AltN:
                    collectStr(1);
                    show( curPos );
                    break;
        case BackSpace:
                    if( !strokeLen ){
                        forceScrSave();
                        break;
                    }
                    TView::handleEvent();
                    return;
#ifndef __NODEBUG__
        case AltG:
                    if( ((char far*)MK_FP(_psp,0x81))[*(char far*)MK_FP(_psp,0x80)] == '\r' )
                        ((char far*)MK_FP(_psp,0x81))[*(char far*)MK_FP(_psp,0x80)] = 0;
                    _fstrncpy( iobuff+500, (char far*)MK_FP( _psp, 0x81 ), 22 );
                    {
                        unsigned short i;
                        _dos_allocmem(0xFFFF,&i);
                        sprintf( iobuff, "\
  \r  Free stack size:%19u\
  \r  Free near memory:%18u\
  \r  Largest near memory:%15u\
  \r  Largest far memory:%16lu\
  \r  Transfer address:         %Fp\
  \r  PSP segment:                   %04X\
  \r  Result file:%23.23s\
  \r  Command line:%22.22s\
  \r  Totals:%23d/%4d\
  \r  ", stackavail(), _memavl(), _memmax(), ((long)i)<<4,
         (void far*)ResAddr,_psp, resultFile,
        iobuff+500, curPos+1, lineCnt );
                    }
                    ::wait( iobuff, bkgInfo, clrInfo );
                    break;
#endif
        default: TView::handleEvent();
                 return;
    }
    strokeLen = 0;
}

void TLevelView::activate(void)
{
    strokeLen=0;
    TView::activate();
}
