#ifndef _TSCREEN_DEF_INT_
#define _TSCREEN_DEF_INT_

#define _CR_UNK     0
#define _CR_OFF     1
#define _CR_NORM    2
#define _CR_BLOCK   3

struct ScreenList{
    void far    *mem;
    ScreenList  *prev;
};

class TScreen{

   public:

	TScreen();

	int x;
	int y;
    static int maxRow;
    static int maxCol;
    static unsigned char far* screenAddr;
    static unsigned char ega;
    static unsigned char videoMode;
    static unsigned char isColor;

	int background;
	int foreground;

    char trackCursor;

    void setxy( int newx, int newy );
    void set_track_cursor(int b);

    void outc( char symbol );
    void outs( char* string );
    void outf( char* format, ... );

    void clrArea( int left, int top, int right, int bottom, char filler = ' ' );
    void clrScreen(char filler = ' ');
    void scroll( int dir, int left, int top, int right, int bottom, int bkg, int clr );
    int cgetDlg( char *str );

    static void selectLine( int left, int top, int right, int background, int text );
    static void screen_setxy(int x, int y);
    static void setcursorsize(char start, char end);
    static void cursoroff(void);
    static void cursornorm(void);
    static void cursorblock(void);
    static void invertColor( int &back, int &text );
    static void far* savescr( void far* buff=(void far*)0 );
    static void restscr( void far* buff, int freemem=1 );
    void push(void);
    void pop(void);

   private:

    unsigned char far* ptr;
    ScreenList *scrstack;
    static unsigned char cursor;

   };

extern TScreen Screen;

#endif
