#include <stdio.h>
#include <stdarg.h>
#include <malloc.h>
#include <dos.h>
#include "tstatus.h"
#include "colors.h"


TStatusLine::TStatusLine( int w )
{
    message = NULL;
    resize(w);
    background = LIGHTGRAY;
    foreground = isColor?RED:BLACK;
    clear();
}

TStatusLine::~TStatusLine()
{
//    background = foreground;
//    clear();
    free( message );
}

void TStatusLine::resize( int w )
{
    length = w?w:maxCol;
    message = (char*)realloc( message, length+2 );
}

void TStatusLine::clear()
{
    message[0] = 0;
    redraw();
}

void TStatusLine::redraw()
{
    setxy( 1, maxRow );
    outf( "%-*s", length, message );
}

void TStatusLine::say( char *fmt, ... )
{
    va_list argptr;

    clear();
    va_start( argptr, fmt );
    vsprintf( message, fmt, argptr );
    va_end( argptr );
    redraw();
}
