#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <malloc.h>
#include "key.h"
#include "tview.h"
#include "country.h"
#include "colors.h"
#include "mouse.h"
#include "slice.h"

char TView::findStr[64];
int  TView::strokeLen;
char TView::NoDraw = 0;
static char found = 0;
void wait( char *mess, int bkg, int clr );

static char *Searching = "Searching...";

void invertColor( int& back, int& text );

void WaitWindow( unsigned char* mess,
		 unsigned char* delm,
		 unsigned int bcolor,
		 unsigned int tcolor,
		 unsigned int dcolor,
		 unsigned int top = 0u,
		 unsigned int left = 0u,
		 unsigned int* topx = 0,
         unsigned int* topy = 0,
         unsigned int shadow = 1,
         unsigned int frame = 1,
         int maxlen = 0
           );


extern int mouseKeyExtend;
extern int mouseEvent;
extern int mouseKey;

TView::TView()
{
  wTop = 2;
  wBottom = maxRow-1;
  wLeft = 1;
  wRight = maxCol;

  wLines = maxRow-2;
  wWidth = maxCol;

  key = 0;
  lastKey = 0;
  lastDirection = 0;
  waitMouse = 1;
  stepoverFlag = 1;
  realviewFlag = 0;

  if( isColor ){
      backgroundText                = BLUE;
      colorText                     = LIGHTGRAY;
      colorSelected                 = LIGHTGRAY     /*LIGHTGRAY*/;
      backgroundSelected            = GREEN         /*CYAN*/ /*BROWN*/;
      colorCurrent                  = BLACK;
      backgroundCurrent             = LIGHTGRAY;
      colorCurrentSelected          = GREEN         /*CYAN*/ /*BLACK*/;
      backgroundCurrentSelected     = LIGHTGRAY     /*YELLOW*/;
      backgroundWindow              = LIGHTGRAY;
      colorWindow                   = BLACK;
      backgroundGet                 = CYAN;
      colorGet                      = BLACK;
      backgroundBar                 = BROWN;
      colorBar                      = BLACK;
      backgroundBarIndicator        = BROWN;
      colorBarIndicator             = WHITE;
    }else{
      backgroundText                = BLACK;
      colorText                     = LIGHTGRAY;
      colorSelected                 = BLUE     /*LIGHTGRAY*/;
      backgroundSelected            = BLACK /*LIGHTGRAY*/     /*CYAN*/ /*BROWN*/;
      colorCurrent                  = WHITE;
      backgroundCurrent             = BLACK /*DARKGRAY*/;
      colorCurrentSelected          = LIGHTBLUE  /*CYAN*/ /*BLACK*/;
      backgroundCurrentSelected     = BLACK /*LIGHTGRAY*/     /*YELLOW*/;
      backgroundWindow              = LIGHTGRAY;
      colorWindow                   = BLACK;
      backgroundGet                 = BLACK;
      colorGet                      = LIGHTGRAY;
      backgroundBar                 = LIGHTGRAY;
      colorBar                      = LIGHTGRAY;
      backgroundBarIndicator        = BLACK;
      colorBarIndicator             = WHITE;
    }

  head = current = NULL;

  lineCnt = curPos = curScr = selectedCnt = 0;

  findStr[ 0 ] = NULL;
  findQuiet = 0;
  strokeLen = 0;
  QuickSearchFlag = 0;
}

int TView::isSelected( void )
{
  return 0;
}

void TView::select( void )
{
  return;
}

void TView::deselect( void )
{
  return;
}

#pragma off (unreferenced)
void TView::wait( char *mess )
{
}
#pragma on (unreferenced)

int TView::selectColor( void )
{
  if( isSelected() ){
    background = backgroundSelected;
    foreground = colorSelected;
  }else{
    background = backgroundText;
    foreground = colorText;
  }
  return background;
}

void TView::handleError( void )
{
  mouseLongUpdate();
  background = BLACK;
  foreground = LIGHTGRAY;
  cursornorm();
  clrScreen();
  disableMouse();
  perror( "Error" );
  exit( 1 );
}

void TView::goTop( void )
{
  if( !curPos )return;
  curPos = curScr = 0;
  draw( 0 );
}

void TView::goBottom( void )
{
  if( curPos >= lineCnt-1 )return;
  draw( lineCnt );
  for( ; curScr < wLines-1 && current  && curPos+1 < lineCnt; next(), curScr++){
    curPos++;
    setxy( wRight, y+1 );
  }
}

void TView::lineUp( void )
{
  char *buffer;

  lastDirection = -1;
  if( curPos < 1 )return;

//  buffer = new char[ wWidth ];
  buffer = (char*)alloca( wWidth );

  if( realviewFlag ){
    while( curScr ){
        prev();
        curScr--;
        curPos--;
        setxy( wRight, y-1 );
        if( !curPos )return;
    }
  }

  selectLine( wLeft, wTop+curScr, wRight, selectColor() ,isSelected()?colorSelected:colorText );
  prev();
  if( curScr > 0 ){
    setxy( wRight, y-1 );
    curScr--;
  }else{
    selectColor();
    disableMouse();
    scroll( -1, wLeft, wTop, wRight-1, wBottom,
            backgroundText, colorText );
    setxy( wLeft, wTop );
    sprintf( buffer, "%.*s", wWidth-1, getLine() );
    outs( buffer );
    while( x<wRight )outc( ' ' );
    setxy( wRight, y );
    enableMouse();
  }
  curPos--;
//  delete buffer;
}

void TView::lineDown( void )
{
  char *buffer;

  lastDirection = 1;
  if( curPos >= lineCnt - 1 )return;

  buffer = (char*)alloca( wWidth );

  if( realviewFlag ){
    while( curScr < wBottom-wTop ){
        next();
        curScr++;
        curPos++;
        setxy( wRight, y+1 );
        if( curPos == lineCnt-1 )return;
    }
  }

  mouseLongUpdate();

  selectLine( wLeft, wTop+curScr, wRight, selectColor() ,isSelected()?colorSelected:colorText  );
  next();
  if( curScr < wLines-1 ){
    setxy( wRight, y+1 );
    curScr++;
  }else{
    selectColor();
    scroll( 1, wLeft, wTop, wRight-1, wBottom,
            backgroundText, colorText );
    setxy( wLeft, wTop+curScr );
    sprintf( buffer, "%.*s", wWidth-1, getLine() );
    outs( buffer );
    while( x<wRight )outc( ' ' );
    setxy( wRight, y );
  }

  mouseEndUpdate();

  curPos++;
//  delete buffer;
}

void TView::pageUp( void )
{
  if( curPos > wLines )
    draw( curPos - wLines - curScr );
  else
    goTop();
}

void TView::pageDown( void )
{
  if( lineCnt - curPos > wLines )
    draw( curPos + wLines - curScr );
  else
    goBottom();
}

/*
void TView::next( void )
{
}

void TView::prev( void )
{
}

char* TView::getLine( void )
{
  return NULL;
}
*/

void TView::activate()
{
  init();
  if( !lineCnt )return;

  cursoroff();

  wWidth = wRight - wLeft + 1;
  wLines = wBottom - wTop + 1;
  show( curPos );
  more = 1;
  while( more ){
    if( !NoDraw )selectLine( wLeft, wTop+curScr, wRight,
        isSelected()?( realviewFlag?backgroundSelected:backgroundCurrentSelected ):( realviewFlag?backgroundText:backgroundCurrent ),
        isSelected()?( realviewFlag?colorSelected:colorCurrentSelected ):( realviewFlag?colorText:colorCurrent ) );
    if( found ){
//      char mess[ 140 ];
//      int i;
      int t, b;

      found--;
//      upper( strcpy( mess, getLine() ) );
//      i = strstr( mess, upper( findStr ) )-mess;
      b = isSelected()?( realviewFlag?backgroundSelected:backgroundCurrentSelected ):( realviewFlag?backgroundText:backgroundCurrent );
      t = isSelected()?( realviewFlag?colorSelected:colorCurrentSelected ):( realviewFlag?colorText:colorCurrent );
      invertColor( b, t );
      selectLine( wLeft+found, wTop+curScr, wLeft+strlen( findStr )+found, b, t );
      found = 0;
    }
    forceUpdate();
    cursoroff();
    lastKey = key;
    scrollBar();
    while( !mkbhit() ){
      lastDirection = 0;
      sliceCritical = 0;
      idle();
    }
    key = mgetch();
    cursoroff();
    forceSequence();
    cursoroff();
    handleEvent();
  }
  deinit();
  cursornorm();
}

void TView::handleEvent( void )
{
    int i, d;

    if( QuickSearchFlag ){
//        int oldOver = stepoverFlag;

        if( key >= ' ' && key <= 255){
            wait( Searching );
            findStr[ strokeLen++ ] = (char)key;
            findStr[ strokeLen ] = 0;
            stepoverFlag = 0;
            if( !find( 1 ) ){
                int sc = curScr, pos = curPos;

                curPos /* = curScr */ = 0;
                current = head;
//                goTop();
                stepoverFlag = 0;
                if( !find(1) ){
                    findStr[ --strokeLen ] = 0;
                    curScr = sc;
                    show( pos );
                    stepoverFlag = 0;
                    find(1);
                }
            }
//            stepoverFlag = oldOver;
            return;
        }else{
            if( strokeLen ){
                if( key == BackSpace ){
                    wait( Searching );
                    findStr[ --strokeLen ] = 0;
                    if( strokeLen ){
                        stepoverFlag = 0;
                        find(1);
                    }
                    return;
                }else{
                    if( key == CtrlEnter ){
                        wait( Searching );
                        stepoverFlag = 1;
                        if( !find( 1 ) ){
                            stepoverFlag = 0;

                            curPos /* = curScr */ = 0; // may be I should not to take over curScr...
                            current = head;
//                            goTop();
                            find( 1 );
                        }
//                        stepoverFlag = oldOver;
                        return;
                    }else{
                        strokeLen = 0;
//                        findStr[ 0 ] = 0;
                    }
                }
            }
        }
    }

    switch( key ){
      case CQuit:
      case Esc:      more = 0;
                     return;
      case Home:
      case CtrlPgUp:
      case CtrlHome: goTop();
                     return;
      case End:
      case CtrlPgDown:
      case CtrlEnd:  goBottom();
                     return;
      case Up:       lineUp();
                     return;
      case Down:     lineDown();
                     return;
      case PgUp:     pageUp();
                     return;
      case PgDown:   pageDown();
                     return;
      case F7:	     if( findDlg() )find();
                     return;
      case ShiftF7:
      case CtrlF7:   find();
                     return;
      case CInvalidate:
                     show( curPos );
                     return;
      case LMB:
_LMB:        if( mouseX == wRight && mouseY >= wTop && mouseY <= wBottom ){
                int fixX, fixY;
                fixX=mouseX; fixY=mouseY;
                draw( (int)((((long)(mouseY-wTop))-((long)(wLines*wLines)/(long)lineCnt)/2l)*(long)lineCnt/(long)(wBottom-wTop)) );
                scrollBar();
                while(mouseStatus())if((fixX!=mouseX) || (fixY!=mouseY)){
                    if( mouseX != wRight )SetMouseXY( wRight, mouseY );
                    mouseStatus();
                    if( mouseY < wTop )SetMouseXY( wRight, wTop );
                    mouseStatus();
                    if( mouseY > wBottom )SetMouseXY( wRight, wBottom );
                    mouseStatus();
                    goto _LMB;
                }
                return;
             }

             if( ( curScr < wBottom-wTop && curScr > 0 ) ||
			 ( (mouseY > wTop || mouseY == wTop && curScr != 0) &&
			   (mouseY < wBottom || mouseY == wBottom && curScr != wBottom-wTop) ) ){
		       if( mouseX <= wRight  && mouseX >= wLeft
		       &&  mouseY <= wBottom && mouseY >= wTop ){
                 if( realviewFlag && mouseY!=wTop && mouseY!=wBottom )return;
                 d = (curScr+wTop < mouseY);
                 while( curScr+wTop != mouseY ){
                   i = curPos;
                   if( d )lineDown();
                   else lineUp();
                   if( i == curPos )return;
                 }
               }else{
                 break;
		       }
		     }else{
		       if( !lastDirection && (mouseY < wTop || mouseY > wBottom) )break;
		       d = 0;
		       if( curScr == 0 && mouseY <= wTop /* && lastDirection==-1*/ )d=-1;
		       if( curScr == wBottom-wTop && mouseY >= wBottom /*&& lastDirection == 1*/)d=1;
		       if( d == 0 )break;
               if( d>0 )lineDown();
               else lineUp();
		     }
             if(lastDirection){
                if(mouseX<wLeft)SetMouseXY(wLeft,mouseY); mouseStatus();
                if(mouseX>wRight-1)SetMouseXY(wRight-1,mouseY); mouseStatus();
                if(mouseY<wTop)SetMouseXY(mouseX,wTop); mouseStatus();
                if(mouseY>wBottom)SetMouseXY(mouseX,wBottom); mouseStatus();
             }
		     return;
    }
    if( waitMouse && (key == LMB || key == RMB || key == MMB) )mouseWaitRelease();
}

/*
void TView::init()
{
}
*/

void TView::deinit()
{
}

void TView::draw( int start )
{
  int i;
  char *buffer;

  if( NoDraw )return;

  buffer = (char*)alloca( wWidth );

//  if( start > lineCnt - wLines - curScr )start = lineCnt - wLines;
  if( start > lineCnt - wLines )start = lineCnt - wLines;
  if( start < 0 )start = 0;
  for( i=0, current=head; i < start; i++ )next();
  curPos = start;

  mouseLongUpdate();

  foreground = colorBar;
  background = backgroundBar;
  clrArea( wRight, wTop, wRight, wBottom, '' );

  setxy( wLeft, wTop );

  for( i=0; current && i<wLines && curPos + i < lineCnt; next(), i++ ){
    if( i ){
        setxy( wLeft, y+1 );
    }
    selectLine( wLeft, wTop+i, wRight, selectColor(), isSelected()?colorSelected:colorText );
    sprintf( buffer, "%-*.*s", wWidth-1, wWidth-1, getLine() );
    outs( buffer );
  }

  if( i < wLines ){
      foreground = colorText;
      background = backgroundText;
      clrArea( wLeft, wTop+i, wRight-1, wBottom );
  }

  while( curPos + i >= lineCnt )i--;
  while( i-- )prev();

  setxy( wRight, wTop+curScr);

  mouseEndUpdate();

  for( i=0; i < curScr; i++ ){
    if( curPos+1 >= lineCnt )break;
    next();
    curPos++;
  }
}

int TView::findDlg( void )
{
  unsigned int x, y;
  char str[66];
  int retval;

  push();
  WaitWindow( (unsigned char*)"Enter search string:                                          \r    ",
          NULL, backgroundWindow, colorWindow, colorWindow, 0u, 0u, &y, &x );
  Screen.setxy( x+1, y+2 );
  Screen.background = backgroundGet;
  Screen.foreground = colorGet;
  Screen.outf( "%-62s", findStr );
  Screen.setxy( x+1, y+2 );
  strcpy( str+2, findStr );
  str[ 0 ] = 62;
  retval = Screen.cgetDlg( str );
  cursoroff();
  strcpy( findStr, str+2 );

  pop();
  if( !str[ 1 ] )retval = 0;
  return retval;
}

int TView::find( int Quietly )
{
  int i;
  char match[ 64 ];
  char mess[ 140 ];

  push();
  if( !strlen( findStr ) ){
    if( !Quietly ){
        ::wait( "   \r   Nothing to find   \r   ", backgroundWindow, colorWindow );
//        mgetch();
//        mouseWaitRelease();
    }
    goto AbortLabel;
  }

  if( !Quietly ){
      sprintf( mess, "   \r   Searching for   \r   %s   \r   ", findStr );
      WaitWindow( (unsigned char*)mess, NULL, backgroundWindow, colorWindow, colorWindow );
  }

  strcpy( match, findStr );
  upper( match );
  if( stepoverFlag )next();
  i = (int)stepoverFlag;
  stepoverFlag = 1;
  for( i+=curPos; current && i < lineCnt; next(), i++ ){
    char *p;

    strcpy( mess, getLine() );
    p = strstr( upper( mess ), match );
    if( p ){
      int start;

      pop();
      if( curPos < curScr ){            // !nonsense!
        curPos = curScr;
      }

      if( curPos-curScr+wLines > i ){
        start = curPos-curScr;
        curScr += i-curPos;
      }else{
        start = i-curScr;
      }
      if( start > lineCnt - wLines && lineCnt >= wLines ){
        start = lineCnt - wLines;
        curScr = i - start;
      }
//      curPos = i;
      draw( start );
      found = (char)(p-mess+1);
      return 1;
    }
  }

  for( i = 0, current = head; i < curPos; i++ )next();

  if( (!findQuiet) && !Quietly ){
    ::wait( "   \r   String was not found   \r   ", backgroundWindow, colorWindow );
//    mgetch();
//    mouseWaitRelease();
  }


AbortLabel:
  pop();
  return 0;
}

void TView::forceUpdate( void )
{
}

void TView::forceSequence( void )
{
}

void TView::idle( void )
{
}


void TView::scrollBar()
{
    int i;
    int begin, end;
    int right = (wRight-1)<<1;

    begin = (int)((((long)(curPos-curScr)*(long)wLines))/((long)lineCnt)) + wTop - 1;
    if( begin < wTop-1 )begin=wTop-1;
    end   = (int)(((long)(wLines*wLines))/(long)lineCnt) + begin;
    if( end < begin )end=begin;

    mouseLongUpdate();
    for( i=wTop-1; i<wBottom; i++ ){
      if( i>=begin && i<=end ){
        screenAddr[ (i*maxCol<<1) + right + 1 ] = (unsigned char)(((backgroundBarIndicator<<4)&0xF0) | (colorBarIndicator&0x0F));
      }else{
        screenAddr[ (i*maxCol<<1) + right + 1 ] = (unsigned char)(((backgroundBar<<4)&0xF0) | (colorBar & 0x0F));
      }
      screenAddr[ (i*maxCol<<1) + right ] = '';
    }
    mouseEndUpdate();
}

void TView::clrWindow()
{

    foreground = colorBar;
    background = backgroundBar;
    clrArea( wRight, wTop, wRight, wBottom, '' );
    foreground = colorText;
    background = backgroundText;
    clrArea( wLeft, wTop, wRight-1, wBottom );

}

void TView::show( int start )
{
    if( curScr >= wLines )curScr = 0;
    if( curScr > start || curScr < start && start < wLines-1 )curScr = start;
//    if( lineCnt > wLines && curPos > lineCnt-wLines )curScr = wLines-(lineCnt-start);
    if( lineCnt > wLines && curPos > lineCnt-wLines+curScr )curScr = wLines-(lineCnt-start);
    draw( start - curScr );
}


void TView::resize( int ntop, int nleft, int nbottom, int nright )
{
    wTop = ntop;
    wBottom = nbottom;
    wLeft = nleft;
    wRight = nright;
    wWidth = wRight - wLeft + 1;
    wLines = wBottom - wTop + 1;
}

void TView::update( void )
{
    show( curPos );
    scrollBar();
}
