#ifndef _TVIEW_DEF_INT_
#define _TVIEW_DEF_INT_

#include "tscreen.h"


class TView :public TScreen{


  public:
    TView();
    int wTop;
    int wBottom;
    int wLeft;
    int wRight;
    int wLines;
    int wWidth;

    int key;
    int lastKey;
    int lastDirection;

    int backgroundText;
    int colorText;
    int colorSelected;
    int backgroundSelected;
    int colorCurrent;
    int backgroundCurrent;
    int colorCurrentSelected;
    int backgroundCurrentSelected;
    int backgroundWindow;
    int colorWindow;
    int backgroundGet;
    int colorGet;
    int colorBar;
    int backgroundBar;
    int colorBarIndicator;
    int backgroundBarIndicator;

    void * head;
    void * current;
    int lineCnt;
    int selectedCnt;
    int curPos;
    int curScr;
    char findQuiet;
    char waitMouse;
    char stepoverFlag;
    char realviewFlag;
    char QuickSearchFlag;
    static char findStr[ 64 ];
    static int strokeLen;
    static char NoDraw;
    char more;

    virtual void init()=0;
    virtual void deinit();
    virtual int  isSelected( void );
    void draw( int start );
    void show( int start );
    virtual void handleEvent( void );
    virtual void select( void );
    virtual void deselect( void );
    virtual void wait( char *mess );
    int  selectColor();
    void resize( int ntop, int nleft, int nbottom, int nright );
    void update( void );

    virtual void handleError( void );

    void clrWindow();

    void lineUp( void );
    void lineDown( void );
    void goTop( void );
    void goBottom( void );
    void pageUp( void );
    void pageDown( void );
    void scrollBar();

    virtual void next( void )=0;
    virtual void prev( void )=0;

    virtual char *getLine( void )=0;

    virtual int  findDlg( void );
    virtual int  find( int Quietly = 0 );

    virtual void forceUpdate( void );
    virtual void forceSequence( void );

    virtual void idle();

    void activate();
  };

#endif
